c
       implicit real*8(a-h,o-z)
       real*8 mu,ms,mm,lambda,M,Kf,Km,KG,Ks
       complex*16 ii,uno,V,a0,a2,a4,a6,t1,t2
       complex*16 a(4),z(4),sol,z1,z2,Vcon
       complex*16 AA,BB,CC,r1,r2,vc,vc1,vc2,vc3
       complex*16 D,FF,S,R
       real*4 L1,L2,L3
c
       print *,'want gam low (realistic, case 1) or high (case 2) (0/1)'
       read *,ides
c
       open(2,file='outB.dat') 
       open(3,file='out.dat') 
       ii=(0.,1.)
       uno=(1.,0.)
       pi=2.*asin(1.)
       f3=1.e+3
       f6=1.e+6
       f9=1.e+9
c values
       phi=0.3
       Ks=35.*f9
       ms=39.*f9
       rhos=2650.
       Kf=2.4*f9
       rhof=1000.
       rho=(1.-phi)*rhos+phi*rhof
       print *,'rho ',rho
       Ak=3.
       Km=Ks*(1.-phi)**(1.+Ak/(1.-phi)) 
       mu=0.8*(ms/Ks)*Km
        Km=1.7*f9
        mu=1.855*f9
c       Km=10.*f9
c       mu=9.*f9
       print *,'Km ',Km/f9
       print *,'mu ',mu/f9
       lambda=Km-2.*mu/3.
       E=lambda+2.*mu
       alpha=1.-Km/Ks
       print *,'alpha ',alpha
       M=Ks/(1.-phi-Km/Ks+phi*Ks/Kf)
       print *,'M ',M/f9
       EG=E+alpha**2*M
       print *,'E EG ',E/f9,EG/f9
       KG=EG-4.*mu/3. 
       print *,'KG ',KG/f9
       eta=0.001
c for Fig 5b
c       eta=0.
       per=1.e-12
       b=eta/per
       Tor=2.
       mm=rhof*Tor/phi
       print *,'vP ',sqrt(EG/rho)
c
c thermo data
       if(ides.eq.0) then
       gam=10.5
       tau=1.5e-8
       else
       gam=4.5e+6
       tau=1.5e-2
       endif
c
       c=820.
c Noda 1990
       alpham=12.e-6 
       alphaf=2.e-4 
       betam=3.*((Km+(alpha-phi)**2*M)*alpham+ 
     .       phi*(alpha-phi)*M*alphaf)
       betaf=3.*phi*M*((alpha-phi)*alpham+phi*alphaf)
       betaf=40000.
       beta=120000.
c      betaf=0.
c      beta=0.

       betam = beta - betaf
       beta = (1.-phi)*betam
c       betaf = phi*betaf
       
       write(6,*)' beta ',beta
       write(6,*)' betam ',betam
       write(6,*)' betaf ' , betaf
       
       T0=300.
c
       f1=-10.
       f2=10.
       n=1000  ! 1000 frecuencias
       do if=1,n
       f=float(if-1)*(f2-f1)/float(n-1)+f1
       freq=10.**f
       om=2.*pi*freq
c
c only Biot
c
       AA=-ii*b*rho+mm*rho*om-om*rhof**2
       BB=ii*b*EG-EG*om*mm-M*om*rho+2.*alpha*M*om*rhof
       CC=E*M*om
       t1=sqrt(BB**2-4.*AA*CC)
       r1=(-BB+t1)/2./AA
       r2=(-BB-t1)/2./AA
       v1=1./real(1./sqrt(r1))
       v2=1./real(1./sqrt(r2))
c      print *,'only Biot ',v1,v2
       V=1.+ii*om*tau
       Vcon=1.-ii*om*tau
       vc=ii*om*gam/V/c
       vc=sqrt(vc)
       v3=1./real(1./vc)
c
        vc1=sqrt(r1)  
        vc2=sqrt(r2)  
        vc3=vc  
       at1=-om*dimag(1./vc1)
       at2=-om*dimag(1./vc2)
       at3=-om*dimag(1./vc3)
       L1=4.*pi*at1*v1/om
       L2=4.*pi*at2*v2/om
       L3=4.*pi*at3*v3/om
c      print *,'only Biot thermal ',v3,sqrt(gam/c/tau)
       write(2,*)f,v1/f3,v2/f3,v3/f3,L1,L2,L3
c
       CC=E*betaf+M*(alpha-1.)*(alpha*betaf-phi*beta)
       D=mm*EG+rho*M-2.*alpha*M*rhof
       FF=betaf*(rho-rhof)+phi*beta*(mm-rhof)
       S=c*EG+T0*beta**2
       R=mm*rho-rhof**2
c
       a0=-ii*om**2*phi*gam*M*E
       a2=om*(c*M*E*phi+b*gam*phi*EG+beta*T0*CC)
       a2=a2+ii*om**2*(gam*phi*D+phi*c*M*E*tau+beta*T0*tau*CC) 
       a4=ii*phi*b*S-om*(b*phi*gam*rho+phi*c*D+phi*b*tau*S+T0*beta*FF)
       a4=a4-ii*om**2*(phi*gam*R+phi*c*tau*D+T0*beta*tau*FF)
       a6=c*phi*(om*R*V-ii*b*rho*Vcon) 
c
c      print *,'a0 ',a0
c      print *,'a2 ',a2
c      print *,'a4 ',a4
c      print *,'a6 ',a6
c
c roots 
c for test
c        a6=1.
c        a4=-1./3.
c        a2=-1./4.
c        a0=1./12.
c
         a(1)=a0/a0
         a(2)=a2/a0 
         a(3)=a4/a0 
         a(4)=a6/a0
         do i=1,4
c        print *,'a(i) ',i,a(i)
         end do
c           stop
         call zroots(a,3,z,.true.)                                      
c
c check
c
 	do i=1,3
c	print *,'root ',i,z(i)
        sol=a6*z(i)**3+a4*z(i)**2+a2*z(i)+a0
c	print *,'zero ',sol
 	end do
c fix step
        if(ides.eq.1) then
        if(f.ge.7.26) then
c       z1=z(1)
c       z2=z(2)
c       z(1)=z2
c       z(2)=z1
        endif
        endif
c        if(if.eq.2) then
c        do it=1,3
c        print *,' z ',z(it)
c        end do
c           stop
c        endif
c
        vc1=sqrt(z(1))  
        vc2=sqrt(z(2))  
        vc3=sqrt(z(3))  
	v1=1./real(1./vc1)
	v2=1./real(1./vc2)
	v3=1./real(1./vc3)
*******************************************
*********************************************

         if(if.eq.1000)then
         f=float(if-1)*(f2-f1)/float(n-1)+f1
         freq=10.**f
         write(6,*)' eta= ' ,eta
         write(6,*)' veloc. at freq = ' ,freq
         print *,if,freq,vc1,vc2,vc3
         print *,if,freq,v1,v2,v3
         
         endif
         
          if(if.eq.600)then
         f=float(if-1)*(f2-f1)/float(n-1)+f1
         freq=10.**f
              write(6,*)' eta= ' ,eta  
         write(6,*)' veloc. at freq = ' ,freq
         print *,if,freq,vc1,vc2,vc3
         print *,if,freq,v1,v2,v3
         
         endif       
       at1=-om*dimag(1./vc1)
       at2=-om*dimag(1./vc2)
       at3=-om*dimag(1./vc3)
       L1=4.*pi*at1*v1/om
       L2=4.*pi*at2*v2/om
       L3=4.*pi*at3*v3/om
       
       at1=-1000.d0*dimag(1./vc1)/dreal(vc1)
       at2=-1000.d0*dimag(1./vc2)/dreal(vc2)
       at3=-1000.d0*dimag(1./vc3)/dreal(vc3)
       
c	print *,'Biot + thermo ',v1,v2,v3

       if(if.eq.1) print *,'v1(0) ',v1
        if(if.eq.1) print *,'v2(0) ',v2     
       if(if.eq.1) print *,'v3(0) ',v3
       
           if(if.eq.600) print *,'v1(n) ',v1
       if(if.eq.600) print *,'v2(n) ',v2      
        if(if.eq.600) print *,'v3(n) ',v3    
        
            if(if.eq.600) print *,'at1 ',at1
       if(if.eq.600) print *,'at2 ',at2      
        if(if.eq.600) print *,'at3 ',at3          
        
       
       if(if.eq.n) print *,'v1(n) ',v1
       if(if.eq.n) print *,'v2(n) ',v2      
        if(if.eq.n) print *,'v3(n) ',v3    
       
  
       
       
       
c

        write(3,*)f,v1/f3,v2/f3,v3/f3,L1,L2,L3
c       write(3,*)f,v1/f3,v2/f3,v3/f3,at1,at2,at3
c
       end do
c
       aaa=1400.*(2600.**2-1200.**2)/f9
       print *,aaa
c
       stop
       end
c
       subroutine zroots(A,M,ROOTS,POLISH)                                      
C       Numerical Recipes, page 265.                                            
C       Given the degree M and the M+1 complex coefficients A of the            
C       polynomial sum (i=1 to M+1) A(i) X^i-1, this routine succesively        
C       calls LAGUER and finds all M complex ROOTS. The logical variable        
C       POLISH should be input as .TRUE. if polishing (also by Laguerre'        
C       s method) is desired, .FALSE. if the roots will be subsequently         
C       polished by other means.                                                
       parameter (eps=1.d-12,maxm=1001)                                           
       complex*16 a(m+1),roots(m),ad(maxm),x,b,c                                   
       logical polish                                                           
       do 11 j=1,m+1                                                            
       ad(j)=a(j)                                                               
11       continue                                                               
       do 13 j=m,1,-1                                                           
       x=cmplx(0.,0.)                                                           
       call laguer(ad,j,x,eps,.FALSE.)                                          
       if(abs(aimag(x)).le.2.*eps**2*abs(real(x))) x=cmplx(real(x),0.)          
       roots(j)=x                                                               
       b=ad(j+1)                                                                
       do 12 jj=j,1,-1                                                          
       c=ad(jj)                                                                 
       ad(jj)=b                                                                 
       b=x*b+c                                                                  
12       continue                                                               
13       continue                                                               
       if(polish)then                                                           
       do 14 j=1,m                                                              
       call laguer(a,m,roots(j),eps,.TRUE.)                                     
14       continue                                                               
       endif                                                                    
       do 16 j=2,m                                                              
       x=roots(j)                                                               
       do 15 i=j-1,1,-1                                                         
       if(real(roots(i)).le.real(x)) go to 10                                   
       roots(i+1)=roots(i)                                                      
15        continue                                                              
       i=0                                                                      
10       roots(i+1)=x                                                           
16       continue                                                               
       return                                                                   
       end                                                                      
c                                                                               
       subroutine laguer(A,M,X,EPS,POLISH)                                      
C       Given the degree M and the M+1 complex coefficients A of the            
C       polynomial sum (i=1 to M+1) A(i) X^i-1, and given EPS the de-           
C       sired fractional accuracy, and given a complex value X, this            
C       routine improves X by Laguerre's method until it converges              
C       to a root of the given polynomial. For normal use POLISH                
C       should be input as .FALSE.. When POLISH is input as .TRUE.,             
C       the routine ignores EPS and instead attempts to improve X               
C       (assumed to be a good initial guess) to the achievable round-           
C       off limit.                                                              
c                                                                               
       complex*16 a(m+1),x,dx,x1,b,d,f,g,h,sq,gp,gm,g2,zero                        
       logical polish                                                           
       parameter (zero=(0.,0.),epss=6.e-12,maxit=1000)                            
       dxold=abs(x)                                                            
       do 12 iter=1,maxit                                                       
       b=a(m+1)                                                                 
       err=abs(b)                                                              
       d=zero                                                                   
       f=zero                                                                   
       abx=abs(x)                                                              
       do 11 j=m,1,-1                                                           
       f=x*f+d                                                                  
       d=x*d+b                                                                  
       b=x*b+a(j)                                                               
       err=abs(b)+abx*err                                                      
11       continue                                                               
       err=epss*err                                                             
       if(abs(b).le.err)then                                                   
       dx=zero                                                                  
       return                                                                   
       else                                                                     
       g=d/b                                                                    
       g2=g*g                                                                   
       h=g2-2.*f/b                                                              
       sq=sqrt((m-1)*(m*h-g2))                                                 
       gp=g+sq                                                                  
       gm=g-sq                                                                  
       if(abs(gp).lt.abs(gm)) gp=gm                                           
       dx=m/gp                                                                  
       endif                                                                    
       x1=x-dx                                                                  
       if(x.eq.x1)return                                                        
       x=x1                                                                     
       cdx=abs(dx)                                                             
       if(iter.gt.6.and.cdx.ge.dxold)return                                     
       dxold=cdx                                                                
       if(.not.polish)then                                                      
       if(abs(dx).le.eps*abs(x)) return                                       
       endif                                                                    
12       continue                                                               
c      pause 'too many iterations'                                              
       return                                                                   
       end                                                                      

