        implicit none
        integer nodes,ntsteps,mlsour,nx,i,k,n
        integer jrec1,jrec2,jsou,npf,npw,nt,nmate
        parameter(nodes=6000,ntsteps=600000,mlsour=1000,nmate=2)
        real*8  source_temp(ntsteps)
        real*8  source_solid(ntsteps)
        real*8  source_fluid(ntsteps)
        real*8 stheta_n(nodes+1),stheta_nm1(nodes+1)
        real*8 stheta_np1(nodes+1)
        real*8 us_n(nodes+1),us_nm1(nodes+1)
        real*8 us_np1(nodes+1)
          real*8 uf_n(nodes+1),uf_nm1(nodes+1)
        real*8 uf_np1(nodes+1)      
        real*8 xnod(nodes),xsou
        real*8 cbeta
    
        real*8 ck(nodes),tauk(nodes),gammak(nodes)
        real*8 rec1_us(ntsteps),rec2_us(ntsteps) 
        real*8 rec1_uf(ntsteps),rec2_uf(ntsteps) 
        real*8 rec1_theta(ntsteps),rec2_theta(ntsteps) 
        real*8 eval1,eval2
        real*8 dt,fcut,freq,stime,dsize,h,vmin_biot,vmax_biot
        real*8 T100,T101,T102,T103
        real*8 DL11,DR11,DL12,DR12,DL21,DL22,DR21,DR22
        real*8 rhok(nodes),rhofk(nodes),rhosk(nodes),phik(nodes)
        real*8 etak(nodes),capak(nodes),ggk(nodes)
        real*8 Ek(nodes),Bk(nodes),Mk(nodes) 
        real*8 arrival1_fast,arrival2_fast
        real*8 arrival1_slow,arrival2_slow
        real*8 pos_rec1,pos_rec2
        real*8 f9
        real*8 ar1_biot1,ar2_biot1,v1_biot,v2_biot
        real*8 ar1_biot2,ar2_biot2
        real*8 href
        real*8 vthetaL,vthetaR,wavel
c                     
        real*8 rhos(nmate),rhof(nmate),phi(nmate)
        real*8 Tor(nmate),gg(nmate),eta(nmate)
        real*8 capa(nmate),T0(nmate),ks(nmate)
        real*8 kf(nmate)
        real*8 km(nmate),mum(nmate),betaf(nmate)
        real*8 gamma(nmate),cc(nmate),beta(nmate)
        real*8 tau(nmate),betam(nmate)
        real*8 m(nmate),b(nmate),E(nmate)
        real*8 ku(nmate)
        integer nmat
        real*8 vfast,vslow,vmin_biot_vmax_biot
        real*8 abcthetaL,abcthetaR,arrival1_theta,arrival2_theta
        open(unit=9,file='r1_solid')
        open(unit=10,file='r2_solid')
        open(unit=11,file='r1_fluid')
        open(unit=12,file='r2_fluid')
        open(unit=14,file='r1_theta')
        open(unit=15,file='r2_theta')
        
        
       call readata(stime,dt,dsize,xsou,freq,fcut,npf,
     1                     h,pos_rec1,pos_rec2,rhos,rhof,
     2                    phi,Tor,gg,eta,capa,T0,ks,kf,
     3                    km,mum,betaf,gamma,cc,beta,tau,betam,
     4                    m,b,ku,E,nt,nx,jsou,jrec1,jrec2,
     5                    DL11,DR11,DL12,DR12,DL21,DR21,
     6                    DL22,DR22,npw,nmat,vfast,vslow,
     7                    vmin_biot,vmax_biot) 
     
              cbeta=beta(1)
  
              if(nmat.eq.2)then 
              do  i=1,nx/2
             etak(i)  = eta(1)
             capak(i) = capa(1)
             phik(i)  = phi(1)
             rhosk(i) = rhos(1)
             rhofk(i) = rhof(1)
             rhok(i)  = (1.d0 - phik(i))*rhosk(i) + phik(i) * rhofk(i)
             ggk(i)   = gg(1)
             Ek(i) = E(1)
             Bk(i) = b(1)
             Mk(i) = m(1)
             tauk(i)  = tau(1)  ! ralaxation time (s)
             ck(i)    = cc(1)        ! bulk specific heat ( m s^2 K (Kelvin))
             gammak(i) = gamma(1)
    
                  enddo 
                  
               do  i=nx/2+1,nx
             etak(i)  = eta(2)
             capak(i) = capa(2)
             phik(i)  = phi(2)
             rhosk(i) = rhos(2)
             rhofk(i) = rhof(2)
             rhok(i)  = (1.d0 - phik(2))*rhosk(2) + phik(2) * rhofk(2)
             ggk(i)   = gg(2)
             Ek(i) = E(2)
             Bk(i) = b(2)
             Mk(i) = m(2)
             tauk(i)  = tau(2)  ! ralaxation time (s)
             ck(i)    = cc(2)        ! bulk specific heat ( m s^2 K (Kelvin))
             gammak(i) = gamma(2)
    
                  enddo  
                   endif
                   
               if(nmat.eq.1)then
                do  i=1,nx
             etak(i)  = eta(1)
             capak(i) = capa(1)
             phik(i)  = phi(1)
             rhosk(i) = rhos(1)
             rhofk(i) = rhof(1)
             rhok(i)  = (1.d0 - phik(i))*rhosk(i) + phik(i) * rhofk(i)
             ggk(i)   = gg(1)
             Ek(i) = E(1)
             Bk(i) = b(1)
             Mk(i) = m(1)
             tauk(i)  = tau(1)  ! ralaxation time (s)
             ck(i)    = cc(1)        ! bulk specific heat ( m s^2 K (Kelvin))
             gammak(i) = gamma(1)
    
                  enddo 
                    endif
                  do i=1,nx+1
                  xnod(i) = (i-1)*h
                  enddo   
   
        eval1 =(xnod(jsou+2)-xsou)/h
         
        eval2 = (xsou-xnod(jsou+1))/h
          write(6,*)'eval1, eval2',eval1, eval2
          write(6,*)        
                
        call sources(freq,fcut,stime,dt,nt,npf,
     1 source_solid,source_fluid,source_temp)
     
        write(6,*)'in driver nx, npw,freq (Hz) ',nx, npw,freq
 
  
          write(6,*)' vmin_biot, vmax_biot' ,vmin_biot,vmax_biot
          write(6,*)
        arrival1_fast = dabs((pos_rec1-xsou))/vfast
        arrival2_fast = dabs((pos_rec2-xsou))/vfast
c         vfluid= dsqrt(Mk(1)/ggk(1))
         
c         write(6,*)' vfluid ' ,dsqrt(Mk(1)/ggk(1))
        arrival1_slow = dabs((pos_rec1-xsou))/vslow
        arrival2_slow = dabs((pos_rec2-xsou))/vslow
        

      
      write(6,*)'jrec1,arrival1 of fast P-wave',jrec1,arrival1_fast
      write(6,*)
      write(6,*)'jrec1,arrival1 of slow P-wave',jrec1,arrival1_slow
        write(6,*)
      write(6,*)'jrec2,arrival2 of fast P-wave ',jrec2,arrival2_fast
      write(6,*) 

      write(6,*)'jrec2,arrival2 of slow P-wave ',jrec2,arrival2_slow
      write(6,*) 
        vthetaL =   dsqrt(gammak(1)/(tauk(1)*ck(1)))  
        vthetaR =   dsqrt(gammak(nx)/(tauk(nx)*ck(nx)))
        write(6,*)'vthetaL,vthetaR ',vthetaL,vthetaR
        write(6,*)
        abcthetaL = tauk(1)*ck(1)*vthetaL/(2.d0*dt)
        abcthetaR = tauk(nx)*ck(nx)*vthetaR/(2.d0*dt)
        
        write(6,*)'abcthetaL,abcthetaR ',abcthetaL,abcthetaR
        
        arrival1_theta = dabs((pos_rec1-xsou))/vthetaL
        arrival2_theta = dabs((pos_rec2-xsou))/vthetaL
 
    
    
      write(6,*)
      write(6,*)'vthetaL, vthetaR' ,vthetaL, vthetaR
       write(6,*)
      
      write(6,*)'jrec1,arrival1_theta of T wave',jrec1,arrival1_theta
      write(6,*)
      write(6,*)'jrec2,arrival2_theta of T-wave',jrec2,arrival2_theta
      write(6,*) 
      
c       stop 1
       
c      set initial values
c
      do  k=1,nx+1
      us_nm1(k)=0.
      us_n(k)=0.
      us_np1(k)=0.
      uf_nm1(k)=0.
      uf_n(k)=0.
      uf_np1(k)=0.
      stheta_nm1(k)=0.
      stheta_n(k)=0.
      stheta_np1(k)=0.     
      
      
      enddo
c      at t=  the system is at rest.
c  so receivers are set to zero until the sources are on
      rec1_theta(1)= 0.d0
      rec2_theta(1)= 0.d0
      rec1_theta(2)= 0.d0
      rec2_theta(2)= 0.d0      
      rec1_us(1)= 0.d0
      rec2_us(1)= 0.d0
      rec1_us(2)= 0.d0
      rec2_us(2)= 0.d0
      
      rec1_uf(1)= 0.d0
      rec2_uf(1)= 0.d0
      rec1_uf(2)= 0.d0
      rec2_uf(2)= 0.d0
      
        do 10 n=1,nt
        if(mod(n,500).eq.0)then
        write(6,*)' ***********************************'
        write(6,*)
         write(6,*)'time  step n = ',n,' time (s)',n*dt
          write(6,*)
        write(6,*)' ***********************************'     
         endif
                
     
c        go to 22
       call calc_biot(dt,h,n,rhok,rhofk,ggk,Ek,Bk,Mk,etak,capak,
     1                nt,nx,source_solid,jsou,jrec1,jrec2,
     2                DL11,DR11,Dl22,DR22,DL12,DR12,
     3        us_nm1,us_n,us_np1,uf_nm1,uf_n,uf_np1,betaf,beta,stheta_n
     4         ,cbeta) 
22      continue       
       call calc_theta(dt,h,n,tauk,ck,gammak,nt,nx,source_temp,
     1                jsou,jrec1,jrec2,rec1_theta,rec2_theta,
     2                abcthetaL,abcthetaR,stheta_nm1,
     3                stheta_n,stheta_np1,
     4                us_nm1,us_n,us_np1,uf_nm1,uf_n,uf_np1,
     5                phik,betam,betaf,T0,cbeta)  
     
               do k=1,nx+1
c   stores  solution in receiver 
         if(k.eq.jrec1)then
        rec1_theta(n)= stheta_np1(k)
        rec1_us(n)= us_np1(k)
        rec1_uf(n) =  uf_np1(k)
  
        write(9,*)n*dt,rec1_us(n)
        write(11,*)n*dt,rec1_uf(n)   
        write(14,*)n*dt,rec1_theta(n)   
  
        endif
 
                enddo
            do k=1,nx+1
          if(k.eq.jrec2)then
        rec2_theta(n)= stheta_np1(k) 
        rec2_us(n)= us_np1(k)
        rec2_uf(n) =  uf_np1(k)
        write(10,*)n*dt,rec2_us(n)
        write(12,*)n*dt,rec2_uf(n)        
        write(15,*)n*dt,rec2_theta(n)   
         
        endif
               enddo
               
             
c     shifts   values for the next time step
c
c
       do  k=1,nx+1
       us_nm1(k) = us_n(k)
       us_n(k)   = us_np1(k)
       uf_nm1(k) = uf_n(k)
       uf_n(k)   = uf_np1(k) 
       stheta_nm1(k) = stheta_n(k)
       stheta_n(k)   = stheta_np1(k)
       enddo
       
10     continue
        
            
             write(6,*)' fort.80 is snapshot at time ',(nt/5)*dt         
             write(6,*)' fort.81 is snapshot at time ',(nt/4)*dt
             write(6,*)' fort.82 is snapshot at time ',(nt/3)*dt
             write(6,*)' fort.83 is snapshot at time ',(nt/2)*dt
             write(6,*)' fort.84 is snapshot at time ',nt*dt
             
        stop
        end
        
***************************************************************
 
    
      subroutine calc_biot(dt,h,n,rhok,rhofk,ggk,Ek,Bk,Mk,etak,capak,
     1                nt,nx,source_solid,jsou,jrec1,jrec2,
     2                DL11,DR11,Dl22,DR22,DL12,DR12,
     3        us_nm1,us_n,us_np1,uf_nm1,uf_n,uf_np1,betaf,beta,stheta_n
     4         ,cbeta)      
     
      implicit none
      integer nodes,ntsteps,mlsour,nx,i,k,n,nt,nmate
      integer jrec1,jrec2,jsou
       parameter(nodes=6000,ntsteps=600000,mlsour=1000,nmate=2)
       real*8  rhok(nodes),Ek(nodes),Bk(nodes),Mk(nodes)
       real*8  tauk(nodes),gammak(nodes)
       real*8  rhofk(nodes),ggk(nodes)
       real*8  etak(nodes),capak(nodes)      
       real*8  source_solid(ntsteps),cc(nodes)
       real*8  us_nm1(nodes),us_n(nodes)
       real*8  us_np1(nodes)
       real*8  uf_nm1(nodes),uf_n(nodes)
       real*8  uf_np1(nodes)      
       real*8  stheta_n(nodes)
       real*8 rhs1(nodes),rhs2(nodes)
       real*8 h
       real*8 dt,betaf(nmate),beta(nmate)
       real*8  vthetaL,vthetaR
       real*8 coef1,coef2,coef3,coef4
       real*8  rec1_us(ntsteps),rec2_us(ntsteps)
       
       real*8 aver_rho,aver_gg,aver_rhof,aver_darcy
       real*8 DL11,DR11,DL12,DR12,DL22,DR22,DL21,DR21
       real*8 a11, a12, a22,deta
       real*8 cbeta
c      write(6,*)' in cacl jrec1, jrec2' ,jrec1,jrec2 
 

      
c     explict loop in time 
 
c     absorbing b.c. at top 
c
c      do k=1,nx
c      ggk(k) = rhok(k)
c      Mk(k) = Ek(k)
c      enddo
        DL11 =  4.7472d6
        DR11 =  4.7472d6
        DL12 = 2.8071d6
        DR12 = 2.8071d6
        DL21= 2.8071d6  
        DR21 = 2.8071d6
        DL22 =  5.8314d6
        DR22 =  5.8314d6      

        k=1
      coef1 = (rhok(1)*h*0.5d0)/(dt**2)
      coef2 = (ggk(1)*h*0.5d0)/(dt**2) 
      coef3 = (rhofk(1)*h*0.5d0)/(dt**2)
      coef4 = ((etak(1)/capak(1))*h*0.5d0)/(2.d0*dt)
      
      a11 = (rhok(1)*h*0.5d0)/(dt**2)+ DL11/(2.d0*dt)
      a22 =  (ggk(1)*h*0.5d0)/(dt**2)+ DL22/(2.d0*dt)
     1       + ((etak(1)/capak(1))*h*0.5d0)/(2.d0*dt)      
      
      a12 = coef3 + DL12/(2.d0*dt)
      
      deta = a11*a22 -a12**2
    
      
      rhs1(1) = coef1*(2.d0*us_n(1)-us_nm1(1))
     1         +coef3*(2.d0*uf_n(1)-uf_nm1(1)) 
     2                  +(DL11/(2.d0*dt))*us_nm1(1)
     2                  +(DL12/(2.d0*dt))*uf_nm1(1)
     3    -(1.d0/h)*( Ek(1)* us_n(1) -
     4                Ek(1)* us_n(2) )
     3    -(1.d0/h)*( Bk(1)* uf_n(1) -
     4                Bk(1)* uf_n(2) )    
     1           + 0.5d0*beta(1)*(stheta_n(1) - stheta_n(2) )

 
        
      rhs2(1) =coef3*( 2.d0*us_n(1)-us_nm1(1) )
     1          +coef2*(2.d0*uf_n(1) - uf_nm1(1))
     1          + coef4*uf_nm1(1)
     
     2          + (DL12/(2.d0*dt))*us_nm1(1)
     2          + (DL22/(2.d0*dt))*uf_nm1(1)
     2       -(1.d0/h)*(Bk(1)*us_n(1)- 
     3         Bk(1)*us_n(2)  )   
     2       -(1.d0/h)*(Mk(1)*uf_n(1)- 
     3         Mk(1)*uf_n(2)  )
     1      +  0.5d0*betaf(1)*(stheta_n(1)-stheta_n(2))
     
        us_np1(1) =  (a22*rhs1(1)- a12*rhs2(1))/deta 
        uf_np1(1) =   (a11*rhs2(1)- a12*rhs1(1))/deta 
        
c        write(90,*)'k, a11,a12,a22,deta',k,a11,a12,a22,deta
c
c    absorbing boundary condition at bottom boundary
c     
           k=nx+1
           
       coef1 = (rhok(nx)*h*0.5d0)/(dt**2)
       coef2 = (ggk(nx)*h*0.5d0)/(dt**2) 
       coef3 = (rhofk(nx)*h*0.5d0)/(dt**2)
       coef4 = ((etak(nx)/capak(nx))*h*0.5d0)/(2.d0*dt)
       
      a11 = (rhok(nx)*h*0.5d0)/(dt**2)+ DR11/(2.d0*dt)
      a22 = (ggk(nx)*h*0.5d0)/(dt**2)+ DR22/(2.d0*dt)
     1       + ((etak(nx)/capak(nx))*h*0.5d0)/(2.d0*dt) 
     
      a12 = (rhofk(nx)*h*0.5d0)/(dt**2)+ DR12/(2.d0*dt)
      
      deta = a11*a22 -a12**2
      
      rhs1(nx+1) =  coef1*(2.d0*us_n(nx+1)-us_nm1(nx+1))+
     2             coef3 * (2.d0*uf_n(nx+1)- uf_nm1(nx+1))

     3             +(DR11/(2.d0*dt))*us_nm1(nx+1)
     3             +(DR12/(2.d0*dt))*uf_nm1(nx+1)
     4    -(1.d0/h)*(- Ek(nx)* us_n(nx) 
     5                + Ek(nx)* us_n(nx+1) )
c     
     4    -(1.d0/h)*(- Bk(nx)* uf_n(nx) 
     5               + Bk(nx)* uf_n(nx+1) )    
     1      +  0.5d0*beta(1)*(stheta_n(nx)-stheta_n(nx+1))
        
       rhs2(nx+1)= coef3*(2.d0*us_n(nx+1)-us_nm1(nx+1) )
     2            +coef2*(2.d0*uf_n(nx+1)-uf_nm1(nx+1) )
     2             + coef4*uf_nm1(nx+1)
     2          + (DR21/(2.d0*dt))*us_nm1(nx+1)
     2          + (DR22/(2.d0*dt))*uf_nm1(nx+1)
     2       -(1.d0/h)*(-Bk(nx)*us_n(nx) 
     3                  + Bk(nx)*us_n(nx+1)  )    
     2       -(1.d0/h)*(-Mk(nx)*uf_n(nx) 
     3                  + Mk(nx)*uf_n(nx+1)  )
     1      +  0.5d0*betaf(1)*(stheta_n(nx)-stheta_n(nx+1))  
     
       us_np1(nx+1) =  (a22*rhs1(nx+1)- a12*rhs2(nx+1))/deta   
     
       uf_np1(nx+1) = (a11*rhs2(nx+1)- a12*rhs1(nx+1))/deta  
c        write(90,*)'k, a11,a12,a22,deta',k,a11,a12,a22,deta 
c
c    interior nodes
c
      do 330 k=2,nx
      aver_rho = rhok(k-1)+rhok(k)
      aver_gg = ggk(k-1)+ggk(k)
      aver_rhof = rhofk(k-1)+rhofk(k)
      
      aver_darcy = etak(k-1)/capak(k-1)+etak(k)/capak(k)
      
      coef1 = (aver_rho*h*0.5d0)/(dt**2)
      coef2 = (aver_gg*h*0.5d0)/(dt**2)
      coef3 = (aver_rhof*h*0.5d0)/(dt**2)
      coef4 = (aver_darcy*h*0.5d0)/(2.d0*dt)
       
      a11 =   (aver_rho*h*0.5d0)/(dt**2)
      a22 =   (aver_gg*h*0.5d0)/(dt**2)
     1       + (aver_darcy*h*0.5d0)/(2.d0*dt)
    
      a12 =   (aver_rhof*h*0.5d0)/(dt**2)
      deta = a11*a22 -a12**2
   
      
      rhs1(k) = coef1*(2.d0*us_n(k)-us_nm1(k))+
     2          coef3 *(2.d0*uf_n(k) - uf_nm1(k))
     3    -(1.d0/h)*(- Ek(k-1)* us_n(k-1)
     4    +(Ek(k-1)+Ek(k))*us_n(k)
     5    - Ek(k)*us_n(k+1) )
     3    -(1.d0/h)*(- Bk(k-1)* uf_n(k-1)
     4    +(Bk(k-1)+Bk(k))*uf_n(k)
     5    - Bk(k)*uf_n(k+1) )   
     1    + 0.5d0*beta(1)*(stheta_n(k-1)-stheta_n(k+1))      
         
        rhs2(k) =coef3 *(2.d0*us_n(k)-us_nm1(k) )
     1          +  coef2*(2.d0*uf_n(k)- uf_nm1(k))
     1          + ((aver_darcy*h*0.5d0)/(2.d0*dt))* uf_nm1(k)
     2       -(1.d0/h)*(-Bk(k-1)*us_n(k-1) 
     3       + (Bk(k-1)+Bk(k))*us_n(k)  
     4       - Bk(k)*us_n(k+1) )  
     2       -(1.d0/h)*(-Mk(k-1)*uf_n(k-1) 
     3       + (Mk(k-1)+Mk(k))*uf_n(k)  
     4       - Mk(k)*uf_n(k+1) )
     1        + 0.5d0*betaf(1)* (stheta_n(k-1)-stheta_n(k+1))    
330         continue           
         do k=2,nx
        
        if(k.eq.jsou)then
            
            rhs1(k)= rhs1(k) 
     1   + source_solid(n)/h
     
       rhs1(k+1)= rhs1(k+1) 
     1      -source_solid(n)/h  
     
       rhs2(k)= rhs2(k) 
     1   + source_solid(n)/h
     
       rhs2(k+1)= rhs2(k+1) 
     1      -source_solid(n)/h  
     
                 endif
        
          enddo
        
            do k=2,nx
       aver_rho = rhok(k-1)+rhok(k)
       aver_gg = ggk(k-1)+ggk(k)
       aver_rhof = rhofk(k-1)+rhofk(k)
       aver_darcy = etak(k-1)/capak(k-1)+etak(k)/capak(k)
       
      coef1 = (aver_rho*h*0.5d0)/(dt**2)
      coef2 = (aver_gg*h*0.5d0)/(dt**2)
      coef3 = (aver_rhof*h*0.5d0)/(dt**2)
      coef4 = (aver_darcy*h*0.5d0)/(2.d0*dt)
      
      a11 =   (aver_rho*h*0.5d0)/(dt**2)
      a22 =   (aver_gg*h*0.5d0)/(dt**2)
     1       + (aver_darcy*h*0.5d0)/(2.d0*dt)
     
      a12 =   (aver_rhof*h*0.5d0)/(dt**2)
      deta = a11*a22 -a12**2
         
c        write(90,*)'k, a11,a12,a22,deta',k,a11,a12,a22,deta
        
      us_np1(k) =  (a22*rhs1(k)- a12*rhs2(k))/deta   
      uf_np1(k) =  (a11*rhs2(k)- a12*rhs1(k))/deta 
        
         enddo
                    do k=1,nx+1
            if(n.eq.nt/5)then
  
            write(80,*)k*h,us_np1(k)
            endif                  
                   
            if(n.eq.nt/4)then
  
            write(81,*)k*h,us_np1(k)
            endif
            
            if(n.eq.nt/3)then
  
            write(82,*)k*h,us_np1(k)
            endif 
            
           if(n.eq.(nt/2))then
   
            write(83,*)k*h,us_np1(k)
            endif                      
            
             if(n.eq.nt)then
  
            write(84,*)k*h,us_np1(k)
            endif                            
            
            enddo 
            
            
                   do k=1,nx+1
              if(n.eq.nt/5)then
  
            write(70,*)k*h,uf_np1(k)
            endif                  
                   
            if(n.eq.nt/4)then
  
            write(71,*)k*h,uf_np1(k)
            endif
            
            if(n.eq.nt/3)then
  
            write(72,*)k*h,uf_np1(k)
            endif 
            
           if(n.eq.(nt/2))then
   
            write(73,*)k*h,uf_np1(k)
            endif                      
            
             if(n.eq.nt)then
  
            write(74,*)k*h,uf_np1(k)
            endif    
            
            enddo   
            
 
       return
       end

***************************************************************

      subroutine calc_theta(dt,h,n,tauk,ck,gammak,nt,nx,source_temp,
     1                jsou,jrec1,jrec2,rec1_theta,rec2_theta,
     2                abcthetaL,abcthetaR,stheta_nm1,
     3                stheta_n,stheta_np1,
     4                us_nm1,us_n,us_np1,uf_nm1,uf_n,uf_np1,
     5                phik,betam,betaf,T0, cbeta)

      implicit none
      integer nodes,ntsteps,mlsour,nx,i,k,n,nt,nmate
      integer jrec1,jrec2,jsou
       parameter(nodes=6000,ntsteps=600000,mlsour=1000,nmate=2)
       real*8 ck(nodes),tauk(nodes),gammak(nodes),phik(nodes)
       real*8  source_temp(ntsteps),cc(nodes)
       real*8  stheta_nm1(nodes),stheta_n(nodes)
       real*8  stheta_np1(nodes)
       real*8 us_n(nodes+1),us_nm1(nodes+1)
       real*8 us_np1(nodes+1)
       real*8 uf_n(nodes+1),uf_nm1(nodes+1)
       real*8 uf_np1(nodes+1)      
       real*8 rhs(nodes)
       real*8 h,betam(nmate),betaf(nmate),T0(nmate)
       real*8 bcthetaL,bcthetaR,dt
       real*8  vthetaL,vthetaR
       real*8 coef1,coef2,coef3,coef
       real*8  rec1_theta(ntsteps),rec2_theta(ntsteps)
       real*8 avertauc,averc
       real*8  Dns_km1,Dns_kp1,Dns_k,Dnf_km1, Dnf_kp1,Dnf_k
       
       real*8  Dnm1s_k,Dnm1s_kp1,Dnp1s_k,Dnp1s_kp1
       real*8  Dnm1f_k,Dnm1f_kp1,Dnp1f_k,Dnp1f_kp1
       
       real*8  D2ns_km1,D2ns_kp1,D2ns_k,D2nf_km1, D2nf_kp1,D2nf_k
       real*8 T100,T101,T102,T103
       real*8 abcthetaL,abcthetaR
       real*8 cbeta
       
c      write(6,*)' in cacl jrec1, jrec2' ,jrec1,jrec2 
 

      
c     explict loop in time 
 
c     absorbing b.c. at top 
c
        k=1
       Dnm1s_k = (1.d0/(2.d0*dt))* (us_nm1(2) - us_nm1(1))
 
       Dnp1s_k = (1.d0/(2.d0*dt))* (us_np1(2) - us_np1(1))

      Dnm1f_k = (1.d0/(2.d0*dt))* (uf_nm1(2) - uf_nm1(1))
 
      Dnp1f_k = (1.d0/(2.d0*dt))* (uf_np1(2) - uf_np1(1)) 

      D2ns_k=(1.d0/dt**2)*(us_np1(1)-2.d0*us_n(1)+ us_nm1(1))
 
      D2ns_kp1=(1.d0/dt**2)*(us_np1(2)-2.d0*us_n(2)+ us_nm1(2))

      D2nf_k=(1.d0/dt**2)*(uf_np1(1)-2.d0*uf_n(1)+ uf_nm1(1))
 
      D2nf_kp1=(1.d0/dt**2)*(uf_np1(2)-2.d0*uf_n(2)+ uf_nm1(2))
 
      T100 = phik(1)*betaf(1)*T0(1)*0.5d0*(Dnp1f_k - Dnm1f_k)
 
      T101 = (1.d0-phik(1))*betam(1)*T0(1)*0.5d0*(Dnp1s_k - Dnm1s_k)
 
      T103 = tauk(1)*phik(1)*betaf(1)*T0(1)*0.5d0*(D2nf_kp1 - D2nf_k)
 
      T102 = tauk(1)*(1.d0-phik(1))*betam(1)*T0(1)*0.5d0
     1       *(D2ns_kp1-D2ns_k)     


      coef1= (tauk(1)*ck(1)*h*0.5d0)/(dt**2) 
      coef2 = (ck(1)*h*0.5d0)/(2.d0*dt)
      
      coef = coef1+coef2+abcthetaL 
      
      rhs(1) = coef1*(2.d0*stheta_n(1)-stheta_nm1(1))+
     2                  coef2*stheta_nm1(1)+ 
     3                  abcthetaL*stheta_nm1(1)
     4    -(1.d0/h)*( gammak(1)* stheta_n(1) -
     5                gammak(1)* stheta_n(2) )
     6   - (T100 +T101 +T102 + T103)   
     
     
        stheta_np1(1) = rhs(1)/coef
c
c    absorbing boundary condition at bottom boundary
c     

        k=nx+1
      
       Dnm1s_k = (1.d0/(2.d0*dt))* (us_nm1(nx+1) - us_nm1(nx)) 
 
       Dnp1s_k = (1.d0/(2.d0*dt))* (us_np1(nx+1) - us_np1(nx))
       
       Dnm1f_k = (1.d0/(2.d0*dt))* (uf_nm1(nx+1) - uf_nm1(nx)) 
 
       Dnp1f_k = (1.d0/(2.d0*dt))* (uf_np1(nx+1) - uf_np1(nx)) 
       
       D2ns_km1=(1.d0/dt**2)*(us_np1(nx)-2.d0*us_n(nx)+ us_nm1(nx)) 
                
       D2ns_k=(1.d0/dt**2)*(us_np1(nx+1)-2.d0*us_n(nx+1)+ us_nm1(nx+1))
       
       D2nf_km1=(1.d0/dt**2)*(uf_np1(nx)-2.d0*uf_n(nx)+ uf_nm1(nx)) 
                
       D2nf_k=(1.d0/dt**2)*(uf_np1(nx+1)-2.d0*uf_n(nx+1)+ uf_nm1(nx+1))
       
       T100 =phik(nx)*betaf(1)*T0(1)*0.5d0*(Dnp1f_k - Dnm1f_k)
       
       T101 = (1.d0-phik(nx))*betam(1)*T0(1)*0.5d0*(Dnp1s_k - Dnm1s_k)
       
       T103 = tauk(nx)*phik(nx)*betaf(1)*T0(1)*0.5d0
     1         *( D2nf_k-D2nf_km1)
       
       T102=tauk(nx)*(1.d0-phik(nx))*betam(1)*T0(1)*0.5d0
     1         *(D2ns_k-D2ns_km1)
       
      coef1= (tauk(nx)*ck(nx)*h*0.5d0)/(dt**2) 
      coef2 = (ck(nx)*h*0.5d0)/(2.d0*dt)
      
      coef = coef1+coef2+abcthetaR
      
      rhs(nx+1) =   coef1*(2.d0*stheta_n(nx+1)-stheta_nm1(nx+1))+
     2             coef2 *stheta_nm1(nx+1)+ 
     3             abcthetaR*stheta_nm1(nx+1)
     4    -(1.d0/h)*(- gammak(nx)* stheta_n(nx) 
     5                + gammak(nx)* stheta_n(nx+1) )
     6     -(T100+T101 +T102 +T103)
        
        stheta_np1(nx+1) = rhs(nx+1)/coef

c
c    interior nodes
c


      do 330 k=2,nx
       Dnm1s_k = (1.d0/(2.d0*dt))* (us_nm1(k) - us_nm1(k-1)) 
 
       Dnm1s_kp1 = (1.d0/(2.d0*dt))* (us_nm1(k+1) - us_nm1(k))
 
       Dnp1s_k = (1.d0/(2.d0*dt))* (us_np1(k) - us_np1(k-1)) 
 
       Dnp1s_kp1 = (1.d0/(2.d0*dt))* (us_np1(k+1) - us_np1(k))
 
       Dnm1f_k = (1.d0/(2.d0*dt))* (uf_nm1(k) - uf_nm1(k-1)) 
 
       Dnm1f_kp1 = (1.d0/(2.d0*dt))* (uf_nm1(k+1) - uf_nm1(k))
 
       Dnp1f_k = (1.d0/(2.d0*dt))* (uf_np1(k) - uf_np1(k-1))
     
       Dnp1f_kp1 = (1.d0/(2.d0*dt))* (uf_np1(k+1) - uf_np1(k))     
 
       D2ns_km1=(1.d0/dt**2)*(us_np1(k-1)-2.d0*us_n(k-1)+us_nm1(k-1)) 
                
       D2ns_k=(1.d0/dt**2)*(us_np1(k)-2.d0*us_n(k)+ us_nm1(k))
 
       D2ns_kp1=(1.d0/dt**2)*(us_np1(k+1)-2.d0*us_n(k+1)+ us_nm1(k+1))
 
       D2nf_km1=(1.d0/dt**2)*(uf_np1(k-1)-2.d0*uf_n(k-1)+ uf_nm1(k-1)) 
                
       D2nf_k=(1.d0/dt**2)*(uf_np1(k)-2.d0*uf_n(k)+ uf_nm1(k))
 
       D2nf_kp1=(1.d0/dt**2)*(uf_np1(k+1)-2.d0*uf_n(k+1)+ uf_nm1(k+1))

        T100 = betaf(1)*T0(1)*0.5d0*phik(k-1)*(Dnp1f_k-Dnm1f_k)
     1      + betaf(1)*T0(1)*0.5d0*phik(k)*(Dnp1f_kp1 - Dnm1f_kp1)
       
       T101 = betam(1)*T0(1)*0.5d0*(1.d0-phik(k-1))*(Dnp1s_k-Dnm1s_k)
     1    + betam(1)*T0(1)*0.5d0*(1.d0-phik(k))*(Dnp1s_kp1-Dnm1s_kp1)
     
       T103=tauk(k-1)*betaf(1)*T0(1)*0.5d0*phik(k-1)*(D2nf_k-D2nf_km1)
     1       +tauk(k)*betaf(1)*T0(1)*0.5d0*phik(k)*(D2nf_kp1-D2nf_k)
        T102=tauk(k-1)*betam(1)*T0(1)*0.5d0*(1.d0-phik(k-1))
     1         *(D2ns_k-D2ns_km1)
     1     + tauk(k)*betam(1)*T0(1)*0.5d0*(1.d0-phik(k))
     1         *(D2ns_kp1-D2ns_k)       
      
      avertauc=tauk(k-1)*ck(k-1)+tauk(k)*ck(k) 
      coef1=( avertauc*h*0.5d0)/(dt**2)
      averc = ck(k-1)+ck(k)
      coef2=( averc *h*0.5d0)/(2.d0*dt)

      coef = coef1+coef2
      
      rhs(k) = coef1*(2.d0*stheta_n(k)-stheta_nm1(k))+
     2          coef2 *stheta_nm1(k)+ 
     3    -(1.d0/h)*(- gammak(k-1)* stheta_n(k-1)
     4    +(gammak(k-1)+gammak(k))*stheta_n(k)
     5    - gammak(k)*stheta_n(k+1) )
     6    -(T100 +T101 +T102 +T103)
330         continue          

         do k=2,nx
         
         avertauc=tauk(k-1)*ck(k-1)+tauk(k)*ck(k) 
         coef1=( avertauc*h*0.5d0)/(dt**2)
         averc = ck(k-1)+ck(k)
         coef2=( averc *h*0.5d0)/(2.d0*dt)     
          coef = coef1+coef2
        
                if(k.eq.jsou)then
            
       rhs(k)= rhs(k) 
     1   + source_temp(n)/h
     
       rhs(k+1)= rhs(k+1) 
     1      -source_temp(n)/h    
     
                 endif
        
          enddo
        
            do k=2,nx
        avertauc=tauk(k-1)*ck(k-1)+tauk(k)*ck(k) 
         coef1=( avertauc*h*0.5d0)/(dt**2)
         averc = ck(k-1)+ck(k)
         coef2=( averc *h*0.5d0)/(2.d0*dt)     
  
        coef = coef1+coef2
        stheta_np1(k) = rhs(k)/coef
        
              enddo
              
                     do k=1,nx+1
            if(n.eq.nt/5)then
  
            write(90,*)k*h,stheta_np1(k)
            endif                  
                   
            if(n.eq.nt/4)then
  
            write(91,*)k*h,stheta_np1(k)
            endif
            
            if(n.eq.nt/3)then
  
            write(92,*)k*h,stheta_np1(k)
            endif 
            
           if(n.eq.(nt/2))then
   
            write(93,*)k*h,stheta_np1(k)
            endif                      
            
             if(n.eq.nt)then
  
            write(94,*)k*h,stheta_np1(k)
            endif                            
            
            enddo              
    
            
 
       return
       end
      
       
       
***************************
      subroutine readata(stime,dt,dsize,xsou,freq,fcut,npf,
     1                     h,pos_rec1,pos_rec2,rhos,rhof,
     2                    phi,Tor,gg,eta,capa,T0,ks,kf,
     3                    km,mum,betaf,gamma,cc,beta,tau,betam,
     4                    m,b,ku,E,nt,nx,jsou,jrec1,jrec2,
     5                    DL11,DR11,DL12,DR12,DL21,DR21,
     6                    DL22,DR22,npw,nmat,vfast,vslow,
     7                    vmin_biot,vmax_biot) 
       
        implicit none
        integer nodes,ntsteps,nx,i,k,n,nt,npf,mlsour,npw,nmate
        integer npar
        parameter(nodes=6000,ntsteps=600000,mlsour=1000,nmate=2)
        real*8 stime,dt,dsize,xsou,freq,fcut,h
        real*8 rhos(nmate),rhof(nmate),phi(nmate)
        real*8 Tor(nmate),gg(nmate),eta(nmate)
        real*8 capa(nmate),T0(nmate),ks(nmate)
        real*8 kf(nmate)
        real*8 km(nmate),mum(nmate),betaf(nmate)
        real*8 gamma(nmate),cc(nmate),beta(nmate)
        real*8 tau(nmate),betam(nmate)
        real*8 m(nmate),b(nmate),E(nmate)
        real*8 ku(nmate),num,den,alpha
        real*8 DL11,DR11,DL12,DR12,DL21,DR21,DL22,DR22
        
        real*8 pos_rec1,pos_rec2
        integer jrec1,jrec2,jsou,nmat
        real*8 vminL, vmaxL,vminR,vmaxR,secfac,hrefL,wavelL
        real*8 hrefR,wavelR,dtL,dtR
        real*8 href,vmin_biot,vmax_biot,wavel
        real*8 vslow,vfast
        real*8 vmin_theta,vmax_theta,abcthetaL,abcthetaR
        real*8 vmin,vthetaL,vthetaR
        
        read(5,*)nmat
        write(6,*)' nmat' ,nmat
        read(5,*)stime
        write(6,*)' stime     ',stime
        read(5,*)dt
        write(6,*)'dt (se cambia)        ',dt
        read(5,*)dsize
        write(6,*)'dsize      ',dsize
        read(5,*)xsou
        write(6,*)'xsou       ',xsou   
        read(5,*)freq
        write(6,*)'freq       ',freq          
        read(5,*)fcut
        write(6,*)'fcut       ',fcut   
        read(5,*)npf
        write(6,*)'npf       ',npf          
        
        read(5,*)h
        write(6,*)'h (se cambia)         ',h
        
        
        
        read(5,*)pos_rec1
        write(6,*)' pos_rec1 ', pos_rec1           
        read(5,*)pos_rec2
        write(6,*)' pos_rec2 ', pos_rec2              
        read(5,*)npw
         write(6,*)' npw  ',npw
    
    
        do 1 i=1,nmat
        
        read(5,*)rhos(i)
        read(5,*)rhof(i) 
        read(5,*)phi(i)
        read(5,*)Tor(i) 
        read(5,*)eta(i)
        read(5,*)capa(i)
            
        read(5,*)T0(i)
        read(5,*)ks(i)
        read(5,*)kf(i)
        read(5,*)km(i)
        read(5,*)mum(i)
        read(5,*)betaf(i)
        read(5,*)gamma(i)
             
        read(5,*)cc(i)
    
        read(5,*)beta(i) 
        
        read(5,*)tau(i)

        write(6,*)' rhos(i)  ',rhos(i) 
        write(6,*)' rhof(i)  ',rhof(i)
        write(6,*)' phi(i)   ',phi(i)
        write(6,*)' Tor(i)   ',Tor(i)  
        write(6,*)' eta(i)   ',eta(i)
        write(6,*)' capa(i)  ',capa(i) 
        write(6,*)' T0(i)    ',T0 (i)
        write(6,*)' ks(i)   ',ks(i)
        write(6,*)' kf(i)    ',kf (i)
        write(6,*)' km(i)    ',km(i)
        write(6,*)' mum(i)   ',mum(i)
        write(6,*)' betaf(i) ',betaf(i)
        write(6,*)' gamma(i) ',gamma(i)
        write(6,*)' cc(i)    ',cc(i)
        write(6,*)' beta(i)  ',beta(i) 
        write(6,*)' tau(i)   ',tau(i)
        betam(i) = beta(i) - betaf(i)
        write(6,*)' betam(i)  ',betam(i) 
        gg(i)= Tor(i)*rhof(i)/phi(i)
        write(6,*)' gg(i)    ',gg(i)
1       continue
 
         
c   computes Biot  properties
        do i=1,nmat
        alpha = 1.d0 - km(i)/ks(i)
        num = ks(i)**2 * kf(i)
        den=ks(i)*phi(i)*(ks(i) - kf(i)) + kf(i)*(ks(i) - km(i))
        m(i) = num/den
        b(i) = alpha *m(i) 
        ku(i) = km(i) + alpha**2 * m(i)
        E(i) = ku(i) + (4.d0/3.d0)* mum(i)
        write(6,*)' Biot elastic constants' 
         
        write(6,*) ' m(i)   ',m(i)
        write(6,*) ' b(i)   ',b(i)
        write(6,*) ' ku(i)  ',ku(i)
        write(6,*) ' E(i)   ',E(i)
        enddo
        
        
        
c   computes ABC for uniform medium

        
        DL11 =  4.7472d6
        DR11 =  4.7472d6
        DL12 = 2.8071d6
        DR12 = 2.8071d6
        DL21= 2.8071d6  
        DR21 = 2.8071d6
        DL22 =  5.8314d6
        DR22 =  5.8314d6      

          vmin_biot = 700.d0
          vmax_biot = 2200.d0
          vslow = vmin_biot
          vfast=vmax_biot
          

        if(nmat.eq.1)then
        
        
        vmin_theta =   dsqrt(gamma(1)/(tau(1)*cc(1)))  
        vmax_theta =   dsqrt(gamma(1)/(tau(1)*cc(1)))
        vmin = vmin_theta
        if(vmin.gt.vmin_biot)then
        vmin= vmin_biot
        endif
        
        wavel = vmin/freq

        href = wavel/npw
        h = href
        secfac = 0.5d0
        dt = ( href/vmax_biot) * secfac
        
        
        endif
        
         wavel = vmin_biot/freq

        href = wavel/npw
        h = href
        secfac = 0.1d0
        dt = ( href/vmax_biot) * secfac
        
        
               write(6,*)' ********************'
               
        write(6,*)' use  vmin_biot' 
        write(6,*)'to compute dt, h for uniform medium'  
      write(6,*)' wavel,vmin,npw  ',wavel,vmin,npw
      
        write(6,*)' ***********************************'
        write(6,*)
      write(6,*)'new  h=href  computed using npw ',href
      write(6,*)
      
  !     dt=0.025d-3

      write(6,*)' new  time step dt (s) ',dt
      write(6,*)
         write(6,*)' ***********************************'     

        
    
        nt = stime/dt 
        if(nt.gt.ntsteps)then
        write(6,*)' nt greather than max. memory allows'
        write(6,*)'parameter  ntsteps must be increased'
        write(6,*)' nt ',nt,' ntsteps ',ntsteps
        
        stop 123456
        endif
        
        nx = dsize/h 
        
        if(nx.gt.nodes)then
         write(6,*)' nx greather than max. memory allows'
        write(6,*)'parameter nodes must be increased'  
        write(6,*)' nx ',nx,' nodes ',nodes
        stop 234567
        endif
        
        jsou = xsou/h 
         jrec1 = pos_rec1/h
         jrec2 = pos_rec2/h+h       
         write(6,*)' in readata' 
  
         write(6,*)' ***********************************'    
         write(6,*)' nt ',nt
         write(6,*)' nx ',nx
         write(6,*)' jsou ',jsou
         write(6,*)' jrec1 ',jrec1       
         write(6,*)' jrec2 ',jrec2         
         

        write(6,*)' salgo de readata' 
            
          return
          end

***************************************************
        subroutine sources(freq,fcut,stime,dt,nt,npf,
     1 source_solid,source_fluid,source_temp)
       
        implicit none
        integer nodes,ntsteps,mlsour,nx,i,k,n,lpulse,nt,jw2
        integer npf
        parameter(nodes=6000,ntsteps=600000,mlsour=1000)
        real*8  source_temp(ntsteps)
        real*8  source_solid(ntsteps)
        real*8  source_fluid(ntsteps)
        
        real*8 pi,twopi,psi,width,w0,alfaf,ts,totpul,fcut
        complex*16 x(mlsour),fsour(mlsour)
        real*8 tt,aux,xmax,stime,freq,dt,fny,fnpf,delf,delw

        open(unit=1,file='temp_source')
        open(unit=2,file='solid_source')
        open(unit=3,file='fluid_source')
        
        open(unit=4,file='amplitud_temp_source')

        
        pi=dabs(4.d0*datan(1.d0))
        twopi = 2.d0*pi
        
c        nt = stime/dt
        write(6,*)'number of time steps',nt

        fny =  1.d0/(2.d0*dt)
        write(6,*)' nyquist frequency  (Hz) = ', fny

        fnpf=npf
        delf=fcut/fnpf
        delw = twopi*delf
        write(6,*)' delf',delf,'delw ',delw
        jw2= fcut/delf  ! last index for frequencies
         
      
      w0 = twopi*freq
      alfaf= .79d0 * w0/pi
      psi=8.d0*freq**2
      width=.5d0/freq
      ts=2.5d0*width
      totpul=3.0d0*ts
      lpulse=totpul/dt+1.0001d0
  
	   
      write(6,*)' w0 = ',w0,'  alfaf = ',alfaf
      write(6,*)' lpulse = ',lpulse
      
       if(lpulse.gt.ntsteps)stop 12345
       
      write(6,*)'psi=',psi,'width=',width,'sec'
      write(6,*)'ts = ', ts, 'totpul',totpul
      write(6,*)'nt = pulse length in samples',nt
 
      if(nt.lt.lpulse)nt=lpulse
      do  n=1,nt
      tt=(n-1)*dt
      aux=psi*(tt-ts)**2
      source_temp(n)=-2.d0*psi*(tt-ts)*exp(-aux)
      enddo
        
c       forces the max value of the source to be one
c
        xmax = 0.d0
        do n=1,nt
        if(dabs(source_temp(n)).gt.xmax) xmax = dabs(source_temp(n))
        enddo

        do  n=1,nt
        source_temp(n) = source_temp(n)/xmax
         if(dabs(source_temp(n)).lt.1.e-14) source_temp(n) = 0.d0
         enddo
         
         do n=1,nt
         source_temp(n) = source_temp(n)
c         source_solid(n) = source_temp(n)*1.d+4
c         source_fluid(n) = source_temp(n)*1.d+4
          
          source_solid(n) = source_temp(n)
c          source_temp(n) = 0.d0
          source_fluid(n) = source_temp(n)
c           source_fluid(n) = 0.d0
         enddo
c
c     writes in 1 source time shape 
c
       write(1,270)((n-1)*dt,source_temp(n),n=1,nt)
       write(2,270)((n-1)*dt,source_solid(n),n=1,nt)
       write(3,270)((n-1)*dt,source_fluid(n),n=1,nt)
       
       
       
270   format(2e20.8)

c
c     computes amplitude and phase of the periodic source
c
    
      call ffu2(source_temp,nt,x,jw2,dt,delw)
      
c     writes amplitude  spectrum in  2
      
       
       write(4,270)((n-1)*delf+.5d0*delf,dsqrt( dreal(x(n))**2
     1              + dimag(x(n))**2),n=1,jw2)
      
      
          return
          end       
**********************************************************************
      subroutine ffu2(u,nt,fu,nw,dt,delw)
      
      implicit none
      integer nodes,ntsteps,mlsour
            parameter(nodes=6000,ntsteps=600000,mlsour=1000)
      integer jw,jt,nt,nw
      real*8 fjw,fjt,v,dt,delw
      real*8 u(ntsteps)
      complex*16  fu(mlsour)
      do  3 jw = 1,nw
      fjw = jw
      fjw = fjw-1.d0
      fjw = fjw + .5d0
      fu(jw) = dcmplx(0.d0,0.d0)
      do 4  jt = 1,nt
      fjt = jt
      fjt = fjt - 1.d0
      v = fjw*delw* fjt*dt
      v=-v
      fu(jw) = fu(jw) + u(jt) * dcmplx(dcos(v),dsin(v))
 4    continue
      fu(jw)=fu(jw)*dt
 
 3    continue
      return
      end 
