        implicit none
        integer nodes,ntsteps,mlsour,nx,i,k,n,j
        integer jrec1,jrec2,jsou,npf,npw,nt,nmate
        parameter(nodes=6000,ntsteps=60000,mlsour=1000,nmate=2)
        real*8  source_temp(ntsteps)
        real*8  source_solid(ntsteps)
        real*8  source_fluid(ntsteps)
        real*8 stheta_n(nodes),stheta_nm1(nodes)
        real*8 stheta_np1(nodes)
        real*8 us_n(nodes),us_nm1(nodes)
        real*8 us_np1(nodes)
          real*8 uf_n(nodes),uf_nm1(nodes)
        real*8 uf_np1(nodes)      
        real*8 xnod(nodes),xsou
    
        real*8 ck(nodes),tauk(nodes),gammak(nodes)
        real*8 rec1_us(ntsteps),rec2_us(ntsteps) 
        real*8 rec1_uf(ntsteps),rec2_uf(ntsteps) 
        real*8 rec1_theta(ntsteps),rec2_theta(ntsteps) 
        real*8 eval1,eval2
        real*8 dt,fcut,freq,stime,dsize,h,vmin_biot,vmax_biot
        real*8 T100,T101,T102,T103
        real*8 DL11,DR11,DL12,DR12,DL21,DL22,DR21,DR22
        real*8 rhok(nodes),rhofk(nodes),rhosk(nodes),phik(nodes)
        real*8 etak(nodes),capak(nodes),ggk(nodes)
        real*8 Ek(nodes),Bk(nodes),Mk(nodes) 
        real*8 arrival1_fast,arrival2_fast
        real*8 arrival1_slow,arrival2_slow
        real*8 pos_rec1,pos_rec2
        real*8 f9
        real*8 ar1_biot1,ar2_biot1,v1_biot,v2_biot
        real*8 ar1_biot2,ar2_biot2
        real*8 href
        real*8 vthetaL,vthetaR,wavel
c                     
        real*8 rhos(nmate),rhof(nmate),phi(nmate)
        real*8 Tor(nmate),gg(nmate),eta(nmate)
        real*8 capa(nmate),T0(nmate),ks(nmate)
        real*8 kf(nmate)
        real*8 km(nmate),mum(nmate),betaf(nmate)
        real*8 gamma(nmate),cc(nmate),beta(nmate)
        real*8 tau(nmate),betam(nmate)
        real*8 m(nmate),b(nmate),E(nmate)
        real*8 ku(nmate)
        integer nmat
        real*8 vfast,vslow,vmin_biot_vmax_biot
        real*8 abcthetaL,abcthetaR,arrival1_theta,arrival2_theta
	    real*8 lhs1(nodes,11), lhs2(nodes,11),lhs3(nodes,11) ! Cambio Juan
	    real*8 rhs1(nodes), rhs2(nodes),rhs3(nodes)	   
        real*8 matrix(3*nodes,11), rhs(3*nodes)
        integer ndim,IA,IB,IJOB
        real*8 XL(3*nodes,11)
        real*8 cbeta, cbetam, cbetaf,cT0
       
        open(unit=9,file='r1_solid')
        open(unit=10,file='r2_solid')
        open(unit=11,file='r1_fluid')
        open(unit=12,file='r2_fluid')
        open(unit=14,file='r1_theta')
        open(unit=15,file='r2_theta')
        
        
       call  readata(stime,dt,dsize,xsou,freq,fcut,npf,
     1                     h,pos_rec1,pos_rec2,rhos,rhof,
     2                    phi,Tor,gg,eta,capa,T0,ks,kf,
     3                    km,mum,betaf,gamma,cc,beta,tau,betam,
     4                    m,b,ku,E,nt,nx,jsou,jrec1,jrec2,
     5                    DL11,DR11,DL12,DR12,DL21,DR21,
     6                    DL22,DR22,npw,nmat,vfast,vslow,
     7                    vmin_biot,vmax_biot) 
     
  !          write(21,*)'betaf', betaf
  
              if(nmat.eq.2)then 
              do  i=1,nx/2
             etak(i)  = eta(1)
             capak(i) = capa(1)
             phik(i)  = phi(1)
             rhosk(i) = rhos(1)
             rhofk(i) = rhof(1)
             rhok(i)  = (1.d0 - phik(i))*rhosk(i) + phik(i) * rhofk(i)
             ggk(i)   = gg(1)
             Ek(i) = E(1)
             Bk(i) = b(1)
             Mk(i) = m(1)
             tauk(i)  = tau(1)  ! ralaxation time (s)
             ck(i)    = cc(1)        ! bulk specific heat ( m s^2 K (Kelvin))
             gammak(i) = gamma(1)
    
                  enddo 
                  
               do  i=nx/2+1,nx
             etak(i)  = eta(2)
             capak(i) = capa(2)
             phik(i)  = phi(2)
             rhosk(i) = rhos(2)
             rhofk(i) = rhof(2)
             rhok(i)  = (1.d0 - phik(2))*rhosk(2) + phik(2) * rhofk(2)
             ggk(i)   = gg(2)
             Ek(i) = E(2)
             Bk(i) = b(2)
             Mk(i) = m(2)
             tauk(i)  = tau(2)  ! ralaxation time (s)
             ck(i)    = cc(2)        ! bulk specific heat ( m s^2 K (Kelvin))
             gammak(i) = gamma(2)
             
    
                  enddo  
              cbeta=beta(1)
              cbetaf=betaf(1)
              cbetam=betam(1)
              cT0=T0(1) 
                   endif
                   
               if(nmat.eq.1)then
                do  i=1,nx
             etak(i)  = eta(1)
             capak(i) = capa(1)
             phik(i)  = phi(1)
             rhosk(i) = rhos(1)
             rhofk(i) = rhof(1)
             rhok(i)  = (1.d0 - phik(i))*rhosk(i) + phik(i) * rhofk(i)
             ggk(i)   = gg(1)
             Ek(i) = E(1)
             Bk(i) = b(1)
             Mk(i) = m(1)
             tauk(i)  = tau(1)  ! ralaxation time (s)
             ck(i)    = cc(1)        ! bulk specific heat ( m s^2 K (Kelvin))
             gammak(i) = gamma(1)
    
    
                  enddo 
              cbeta=beta(1)
              cbetaf=betaf(1)
              cbetam=betam(1)
              cT0=T0(1) 
                    endif
                  do i=1,nx+1
                  xnod(i) = (i-1)*h
                  enddo   
                  
             write(21,*)'betaf', betaf      
   
        eval1 =(xnod(jsou+2)-xsou)/h
         
        eval2 = (xsou-xnod(jsou+1))/h
          write(6,*)'eval1, eval2',eval1, eval2
          write(6,*)        
         
        call sources(freq,fcut,stime,dt,nt,npf,
     1 source_solid,source_fluid,source_temp)
     
        write(6,*)'in driver nx, npw,freq (Hz) ',nx, npw,freq
 
  
          write(6,*)' vmin_biot, vmax_biot' ,vmin_biot,vmax_biot
          write(6,*)
        arrival1_fast = dabs((pos_rec1-xsou))/vfast
        arrival2_fast = dabs((pos_rec2-xsou))/vfast
c         vfluid= dsqrt(Mk(1)/ggk(1))
         
c         write(6,*)' vfluid ' ,dsqrt(Mk(1)/ggk(1))
        arrival1_slow = dabs((pos_rec1-xsou))/vslow
        arrival2_slow = dabs((pos_rec2-xsou))/vslow
        

      
      write(6,*)'jrec1,arrival1 of fast P-wave',jrec1,arrival1_fast
      write(6,*)
      write(6,*)'jrec1,arrival1 of slow P-wave',jrec1,arrival1_slow
        write(6,*)
      write(6,*)'jrec2,arrival2 of fast P-wave ',jrec2,arrival2_fast
      write(6,*) 

      write(6,*)'jrec2,arrival2 of slow P-wave ',jrec2,arrival2_slow
      write(6,*) 
        vthetaL =   dsqrt(gammak(1)/(tauk(1)*ck(1)))  
        vthetaR =   dsqrt(gammak(nx)/(tauk(nx)*ck(nx)))
        write(6,*)'vthetaL,vthetaR ',vthetaL,vthetaR
        write(6,*)
        abcthetaL = tauk(1)*ck(1)*vthetaL/(2.d0*dt)
        abcthetaR = tauk(nx)*ck(nx)*vthetaR/(2.d0*dt)
        
        write(6,*)'abcthetaL,abcthetaR ',abcthetaL,abcthetaR
        
        arrival1_theta = dabs((pos_rec1-xsou))/vthetaL
        arrival2_theta = dabs((pos_rec2-xsou))/vthetaL
 
    
    
      write(6,*)
      write(6,*)'vthetaL, vthetaR' ,vthetaL, vthetaR
       write(6,*)
      
      write(6,*)'jrec1,arrival1_theta of T wave',jrec1,arrival1_theta
      write(6,*)
      write(6,*)'jrec2,arrival2_theta of T-wave',jrec2,arrival2_theta
      write(6,*) 
      
 !      stop 1
       
c      set initial values
c
      do  k=1,nx+1
      us_nm1(k)=0.
      us_n(k)=0.
      us_np1(k)=0.
      uf_nm1(k)=0.
      uf_n(k)=0.
      uf_np1(k)=0.     
      enddo
c      at t=  the system is at rest.
c  so receivers are set to zero until the sources are on
      rec1_theta(1)= 0.d0
      rec2_theta(1)= 0.d0
      rec1_theta(2)= 0.d0
      rec2_theta(2)= 0.d0      
      rec1_us(1)= 0.d0
      rec2_us(1)= 0.d0
      rec1_us(2)= 0.d0
      rec2_us(2)= 0.d0
      
      rec1_uf(1)= 0.d0
      rec2_uf(1)= 0.d0
      rec1_uf(2)= 0.d0
      rec2_uf(2)= 0.d0
      
        
        do 10 n=1,nt
 
        
        if(mod(n,1).eq.0)then
        write(6,*)' ***********************************'
        write(6,*)
         write(6,*)'time  step n = ',n,' time (s)',n*dt
          write(6,*)
        write(6,*)' ***********************************'     
         endif
 

 
 
       call calc_biot(dt,h,n,rhok,rhofk,ggk,Ek,Bk,Mk,etak,capak,
     1                phik,ck,  
     1                nt,nx,source_solid,source_fluid,source_temp,
     2                jsou,jrec1,jrec2,
     2                DL11,DR11,Dl22,DR22,DL12,DR12,
     3        us_nm1,us_n,uf_nm1,uf_n,cbetaf,cbetam,cbeta,cT0,
     4        stheta_n,stheta_nm1,
     4        lhs1,lhs2,lhs3,rhs1,rhs2,rhs3,abcthetaL,abcthetaR,
     5        us_np1,uf_np1)       
     
        call calc_theta(dt,h,n,rhok,rhofk,ggk,Ek,Bk,Mk,etak,capak,
     1                phik,ck,gammak,tauk,  
     1                nt,nx,source_solid,source_fluid,source_temp,
     2                jsou,jrec1,jrec2,
     2                DL11,DR11,Dl22,DR22,DL12,DR12,
     3        us_nm1,us_n,uf_nm1,uf_n,cbetaf,cbetam,cbeta,cT0,
     4        stheta_n,stheta_nm1,stheta_np1,
     4        lhs1,lhs2,lhs3,rhs1,rhs2,rhs3,abcthetaL,abcthetaR
     5        ,us_np1,uf_np1) 

  
              
             do k=1,nx+1
            if(n.eq.nt/5)then
  
            write(80,*)k*h,us_np1(k)
            endif                  
                   
            if(n.eq.nt/4)then
  
            write(81,*)k*h,us_np1(k)
            endif
            
            if(n.eq.nt/3)then
  
            write(82,*)k*h,us_np1(k)
            endif 
            
           if(n.eq.(nt/2))then
   
            write(83,*)k*h,us_np1(k)
            endif                      
            
             if(n.eq.nt)then
  
            write(84,*)k*h,us_np1(k)
            endif                            
      
            
            
            enddo              
            

           
              
             do k=1,nx+1
            if(n.eq.nt/5)then
  
            write(70,*)k*h,uf_np1(k)
            endif                  
                   
            if(n.eq.nt/4)then
  
            write(71,*)k*h,uf_np1(k)
            endif
            
            if(n.eq.nt/3)then
  
            write(72,*)k*h,uf_np1(k)
            endif 
            
           if(n.eq.(nt/2))then
   
            write(73,*)k*h,uf_np1(k)
            endif                      
            
             if(n.eq.nt)then
  
            write(74,*)k*h,uf_np1(k)
            endif                            
            
            enddo                         

                     do k=1,nx+1
            if(n.eq.nt/5)then
  
            write(90,*)k*h,stheta_np1(k)
            endif                  
                   
            if(n.eq.nt/4)then
  
            write(91,*)k*h,stheta_np1(k)
            endif
            
            if(n.eq.nt/3)then
  
            write(92,*)k*h,stheta_np1(k)
            endif 
            
           if(n.eq.(nt/2))then
   
            write(93,*)k*h,stheta_np1(k)
            endif                      
            
             if(n.eq.nt)then
  
            write(94,*)k*h,stheta_np1(k)
            endif                            
            
            enddo                         
            
    
               do k=1,nx+1
c   stores  solution in receiver 
         if(k.eq.jrec1)then
        rec1_us(n)= us_np1(k)
        rec1_uf(n) =  uf_np1(k)
  
        write(9,*)n*dt,rec1_us(n)
        write(11,*)n*dt,rec1_uf(n)   
        rec1_theta(n)= stheta_np1(k)
   
 
        write(14,*)n*dt,rec1_theta(n)   
  
        endif
 
                enddo
            do k=1,nx+1
          if(k.eq.jrec2)then 
        rec2_us(n)= us_np1(k)
        rec2_uf(n) =  uf_np1(k)
        write(10,*)n*dt,rec2_us(n)
        write(12,*)n*dt,rec2_uf(n)        
           rec2_theta(n)= stheta_np1(k) 
 
        write(15,*)n*dt,rec2_theta(n)   
         
        endif
               enddo
               
             
c     shifts   values for the next time step
c
c
       do  k=1,nx+1
       us_nm1(k) = us_n(k)
       us_n(k)   = us_np1(k)
       uf_nm1(k) = uf_n(k)
       uf_n(k)   = uf_np1(k) 
       
       stheta_nm1(k) = stheta_n(k)
       stheta_n(k)   = stheta_np1(k)
       enddo
       
 
       
10     continue
        
  
  
            
             write(6,*)' fort.80 is snapshot at time ',(nt/5)*dt         
             write(6,*)' fort.81 is snapshot at time ',(nt/4)*dt
             write(6,*)' fort.82 is snapshot at time ',(nt/3)*dt
             write(6,*)' fort.83 is snapshot at time ',(nt/2)*dt
             write(6,*)' fort.84 is snapshot at time ',nt*dt
             
        stop
        end
        
***************************************************************
 
    
      subroutine calc_biot(dt,h,n,rhok,rhofk,ggk,Ek,Bk,Mk,etak,capak,
     1                phik,ck,  
     1                nt,nx,source_solid,source_fluid,source_temp,
     2                jsou,jrec1,jrec2,
     2                DL11,DR11,Dl22,DR22,DL12,DR12,
     3        us_nm1,us_n,uf_nm1,uf_n,cbetaf,cbetam,cbeta,cT0,
     4        stheta_n,stheta_nm1,
     4        lhs1,lhs2,lhs3,rhs1,rhs2,rhs3,abcthetaL,abcthetaR,
     5        us_np1,uf_np1)  
     
 
      implicit none
      integer nodes,ntsteps,mlsour,nx,i,k,n,nt,nmate
      integer jrec1,jrec2,jsou
       parameter(nodes=6000,ntsteps=60000,mlsour=1000,nmate=2)
       real*8  rhok(nodes),Ek(nodes),Bk(nodes),Mk(nodes)
       real*8  tauk(nodes),gammak(nodes)
       real*8  rhofk(nodes),ggk(nodes)
       real*8  etak(nodes),capak(nodes)
       real*8  phik(nodes),ck(nodes)
       real*8  cc(nodes)
        real*8  source_temp(ntsteps)
        real*8  source_solid(ntsteps)
        real*8  source_fluid(ntsteps)
        
       real*8  us_nm1(nodes),us_n(nodes),us_np1(nodes)
       real*8  uf_nm1(nodes),uf_n(nodes),uf_np1(nodes)
       
       real*8  stheta_n(nodes),stheta_nm1(nodes)
       real*8 rhs1(nodes),rhs2(nodes),rhs3(nodes)
       real*8 h
       real*8 dt,betaf(nmate),beta(nmate)
       real*8  vthetaL,vthetaR,abcthetaL,abcthetaR
       real*8 coef1,coef2,coef3,coef4
       real*8  rec1_us(ntsteps),rec2_us(ntsteps)
       
       real*8 aver_rho,aver_gg,aver_rhof,aver_darcy
       real*8 DL11,DR11,DL12,DR12,DL22,DR22,DL21,DR21
       real*8 a11, a12, a22,deta
c      write(6,*)' in cacl jrec1, jrec2' ,jrec1,jrec2 
	   real*8 lhs1(nodes,11),lhs2(nodes,11) ! Cambio Juan
	   real*8 lhs3(nodes,11)
       real*8 cbeta,cbetam,cbetaf,cT0
       real*8  Dns_km1,Dns_kp1,Dns_k,Dnf_km1, Dnf_kp1,Dnf_k
       real*8  D2ns_km1,D2ns_kp1,D2ns_k,D2nf_km1, D2nf_kp1,D2nf_k
       real*8 T100,T101,T102,T103, aux1,aux2
       real*8 avertauc,averc,coef
       real*8 bb(2*(nodes+1),7),rhs(2*(nodes+1)),xx(2*(nodes+1))
       integer l,j
       
c       write(6,*)' enters calc_biot, solves for tiem step n',n
c       
c       write(6,*)' nodes is max. number of subintervals (nx.le.nodes)' 
c       write(6,*)' 2*(nodes+1) = max number of unknowns'
       
c     absorbing b.c. at top 
c
c      do k=1,nx
c      ggk(k) = rhok(k)
c      Mk(k) = Ek(k)
c      enddo
        DL11 =  4.7472d6
        DR11 =  4.7472d6
        DL12 = 2.8071d6
        DR12 = 2.8071d6
        DL21= 2.8071d6  
        DR21 = 2.8071d6
        DL22 =  5.8314d6
        DR22 =  5.8314d6
        
C    Starts band matrix calculation, 7 diagonals   
        k=1
c  1rst solid eqn         
       bb(1,1) = 0.d0               ! siempre cero
       bb(1,2) = 0.d0               ! coef of u^s(k-1),cero aqui
       bb(1,3) = 0.d0                ! of u^f(k-1),cero aqui
       bb(1,4) = (rhok(1)*h*0.5d0)/(dt**2)+ DL11/(2.d0*dt)
     1           + Ek(1)/(2.d0*h)                           ! coef. of u^s(1)
       bb(1,5) = (rhofk(1)*h*0.5d0)/(dt**2)+ DL12/(2.d0*dt)
     1           + Bk(1)/(2.d0*h)                            ! coef. of u^f(1)
       
       bb(1,6) = -Ek(1)/(2.d0*h)  ! coef. u^s(2)
       bb(1,7) =  -Bk(1)/(2.d0*h)  ! coef. u^f(2)

  !     write(7,*)' row 1'
   !    write(7,*)(bb(1,k),k=1,7)
       
    
       
       
c   first fluid eqn

        bb(2,1) = 0.d0         ! ! coef. of u^s(k-1),cero aqui
        bb(2,2) = 0.d0         !   coef. of u^f(k-1),cero aqui
        bb(2,3) = (rhofk(1)*h*0.5d0)/(dt**2)+ DL21/(2.d0*dt) ! coef. of u^s(1)
     1                +Bk(1)/(2.d0*h)    
        bb(2,4) = (ggk(1)*h*0.5d0)/(dt**2)+ DL22/(2.d0*dt)
     1       + ((etak(1)/capak(1))*h*0.5d0)/(2.d0*dt) ! coef. of u^f(1)
     1            +Mk(1)/(2.d0*h)
     
        bb(2,5) =    -Bk(1)/(2.d0*h)! coef. u^s(2)                       
        bb(2,6) =    -Mk(1)/(2.d0*h)! coef. u^f(2)
     
        bb(2,7) =  0.d0   !siempre cero
        
 !        write(7,*)' row 2'
  !       write(7,*)(bb(2,k),k=1,7)      
c          kfin=(nx-2)/2   en el codigo en frecuencia nx = nro de incognitas
c           stop 2
          
            do k=2,nx
         aver_gg = ggk(k-1)+ggk(k)
         aver_rhof = rhofk(k-1)+rhofk(k)
         aver_darcy = etak(k-1)/capak(k-1)+etak(k)/capak(k)
            
c  solid eqn
          bb(2*k-1,1) = 0.d0 ! cero   aqui
          bb(2*k-1,2) =   - Ek(k-1)/(2.d0*h) ! coef. of u^s(k-1)       
          bb(2*k-1,3) =       - Bk(k-1)/(2.d0*h) ! coef. of u^f(k-1)
          bb(2*k-1,4) =   ((rhok(k-1)+rhok(k))*h*0.5d0)/(dt**2)
     1               + (Ek(k-1) + Ek(k))/(2.d0*h) ! coef. of u^s(k)
          bb(2*k-1,5) =  ((rhofk(k-1)+rhofk(k))*h*0.5d0)/(dt**2)
     1                + (Bk(k-1) + Bk(k))/(2.d0*h) ! coef. of u^f(k)
          bb(2*k-1,6) =  - Ek(k)/(2.d0*h) ! coef. of u^s(k+1)
     
          bb(2*k-1,7) =  - Bk(k)/(2.d0*h) ! coef. of u^f(k+1)

c fluid eqn

         
           bb(2*k,1) = -Bk(k-1)/(2.d0*h) ! coef. of u^s(k-1)
           bb(2*k,2) = -Mk(k-1)/(2.d0*h)  ! coef.of u^f(k-1)
           bb(2*k,3) = (aver_rhof*h*0.5d0)/(dt**2)  
     1                  + (Bk(k-1) + Bk(k))/(2.d0*h) ! coef. of u^s(k)
           bb(2*k,4) = (aver_gg*h*0.5d0)/(dt**2)
     1       + (aver_darcy*h*0.5d0)/(2.d0*dt)
     1                  + (Mk(k-1) + Mk(k))/(2.d0*h) ! coef. of u^f(k)
  
           bb(2*k,5) =  -Bk(k)/(2.d0*h) ! coef. of u^s(k+1)
            
           bb(2*k,6) =  -Mk(k)/(2.d0*h) ! coef. of u^f(k+1)
     
           bb(2*k,7) = 0.d0
  !          write(7,*)' solid row 2*k-1', 2*k-1
  !          write(7,*)(bb(2*k-1,j),j=1,7)
  !          write(7,*)
  !          write(7,*)' fluid row 2*k', 2*k
 !           write(7,*)(bb(2*k,j),j=1,7)
  !          write(7,*)          
           end do   
        
 
         k=2*nx+1
c  last solid eqn

       bb(2*nx+1,1) = 0.d0 ! siempre son cero
       bb(2*nx+1,2) = -Ek(nx)/(2.d0*h)  ! coef. u^s(nx)
       bb(2*nx+1,3) =  -Bk(nx)/(2.d0*h)  ! coef. u^f(nx)
       bb(2*nx+1,4) = (rhok(nx)*h*0.5d0)/(dt**2)+ DR11/(2.d0*dt)
     1               + Ek(nx)/(2.d0*h)     ! coef. of u^s(nx+1) 
  
       bb(2*nx+1,5) = (rhofk(nx)*h*0.5d0)/(dt**2)+ DR12/(2.d0*dt)
     1               + Bk(nx)/(2.d0*h)    ! coef. of u^f(nx+1)
  
       bb(2*nx+1,6) = 0.d0 
       bb(2*nx+1,7) = 0.d0 
   !           write(7,*)' last solid row '
   !      write(7,*)(bb(2*nx+1,k),k=1,7)
   !      write(7,*)
c  last fluid eqn       
       
      bb(2*(nx+1),1) =  -Bk(nx)/(2.d0*h) ! coef. of u^s(nx)
      bb(2*(nx+1),2)   =   -Mk(nx)/(2.d0*h) ! coef. of u^f(nx)
      
      bb(2*(nx+1),3) = (rhofk(nx)*h*0.5d0)/(dt**2)+ DR21/(2.d0*dt)
     1               + Bk(nx)/(2.d0*h)  ! coef. of u^s(nx+1)
      
      bb(2*(nx+1),4) = (ggk(nx)*h*0.5d0)/(dt**2)+ DR22/(2.d0*dt)
     1       + ((etak(nx)/capak(nx))*h*0.5d0)/(2.d0*dt) 
     1        + Mk(nx)/(2.d0*h)             ! coef. of u^f(nx+1)
     
      bb(2*(nx+1),5) = 0.d0
     
      bb(2*(nx+1),6) = 0.d0
      bb(2*(nx+1),7) = 0.d0

    !          write(7,*)' last fluid row '
    !     write(7,*)(bb(2*(nx+1),k),k=1,7)
    !     write(7,*)
c      stop 4
      coef1 = (rhok(1)*h*0.5d0)/(dt**2)
      coef2 = (ggk(1)*h*0.5d0)/(dt**2) 
      coef3 = (rhofk(1)*h*0.5d0)/(dt**2)
      coef4 = ((etak(1)/capak(1))*h*0.5d0)/(2.d0*dt)
      
      rhs(1) = coef1*(2.d0*us_n(1)-us_nm1(1))
     1         +coef3*(2.d0*uf_n(1)-uf_nm1(1)) 
     2                  +(DL11/(2.d0*dt))*us_nm1(1)
     2                  +(DL12/(2.d0*dt))*uf_nm1(1)
     3    -(1.d0/(2.d0*h))*( Ek(1)* us_nm1(1) -
     4                Ek(1)* us_nm1(2) )
     3    -(1.d0/(2.d0*h))*( Bk(1)* uf_nm1(1) -
     4                Bk(1)* uf_nm1(2) )
     5    +0.5d0*cbeta*stheta_n(1)
     6    -0.5d0*cbeta*stheta_n(2)     
   
      rhs(2) =coef3*( 2.d0*us_n(1)-us_nm1(1) )
     1          +coef2*(2.d0*uf_n(1) - uf_nm1(1))
     1          + coef4*uf_nm1(1)
     
     2          + (DL21/(2.d0*dt))*us_nm1(1)
     2          + (DL22/(2.d0*dt))*uf_nm1(1)
     2       -(1.d0/(2.d0*h))*(Bk(1)*us_nm1(1)- 
     3         Bk(1)*us_nm1(2)  )   
     2       -(1.d0/(2.d0*h))*(Mk(1)*uf_nm1(1)- 
     3         Mk(1)*uf_nm1(2)  )
     5    +0.5d0*cbetaf*stheta_n(1)
     6    -0.5d0*cbetaf*stheta_n(2)    
   

c
c    absorbing boundary condition at bottom boundary
c    
           k=nx+1
           
       coef1 = (rhok(nx)*h*0.5d0)/(dt**2)
       coef2 = (ggk(nx)*h*0.5d0)/(dt**2) 
       coef3 = (rhofk(nx)*h*0.5d0)/(dt**2)
       coef4 = ((etak(nx)/capak(nx))*h*0.5d0)/(2.d0*dt)
       
     
      rhs(2*(nx+1)-1) =  coef1*(2.d0*us_n(nx+1)-us_nm1(nx+1))+
     2             coef3 * (2.d0*uf_n(nx+1)- uf_nm1(nx+1))

     3             +(DR11/(2.d0*dt))*us_nm1(nx+1)
     3             +(DR12/(2.d0*dt))*uf_nm1(nx+1)
     4    -(1.d0/(2.d0*h))*(- Ek(nx)* us_nm1(nx) 
     5                + Ek(nx)* us_nm1(nx+1) )
c     
     4    -(1.d0/(2.d0*h))*(- Bk(nx)* uf_nm1(nx) 
     5               + Bk(nx)* uf_nm1(nx+1) )    
     6    +0.5d0*cbeta*stheta_n(nx)
     7    -0.5d0*cbeta*stheta_n(nx+1) 
        
       rhs(2*(nx+1))= coef3*(2.d0*us_n(nx+1)-us_nm1(nx+1) )
     2            +coef2*(2.d0*uf_n(nx+1)-uf_nm1(nx+1) )
     2             + coef4*uf_nm1(nx+1)
     2          + (DR21/(2.d0*dt))*us_nm1(nx+1)
     2          + (DR22/(2.d0*dt))*uf_nm1(nx+1)
     2       -(1.d0/(2.d0*h))*(-Bk(nx)*us_nm1(nx) 
     3                  + Bk(nx)*us_nm1(nx+1)  )    
     2       -(1.d0/(2.d0*h))*(-Mk(nx)*uf_nm1(nx) 
     3                  + Mk(nx)*uf_nm1(nx+1)  )
     6    +0.5d0*cbetaf*stheta_n(nx)
     7    -0.5d0*cbetaf*stheta_n(nx+1)  
    
c
c    interior nodes
c
      do 330 k=2,nx
      aver_rho = rhok(k-1)+rhok(k)
      aver_gg = ggk(k-1)+ggk(k)
      aver_rhof = rhofk(k-1)+rhofk(k)
      aver_darcy = etak(k-1)/capak(k-1)+etak(k)/capak(k)
      
      coef1 = (aver_rho*h*0.5d0)/(dt**2)
      coef2 = (aver_gg*h*0.5d0)/(dt**2)
      coef3 = (aver_rhof*h*0.5d0)/(dt**2)
      coef4 = (aver_darcy*h*0.5d0)/(2.d0*dt)
       
      
      rhs(2*k-1) = coef1*(2.d0*us_n(k)-us_nm1(k))+
     2          coef3 *(2.d0*uf_n(k) - uf_nm1(k))
     3    -(1.d0/(2.d0*h))*(- Ek(k-1)* us_nm1(k-1)  ! Juan correccion  25 marzo 2022
     4    +(Ek(k-1)+Ek(k))*us_nm1(k)    ! Juan correccion  25 marzo 2022
     5    - Ek(k)*us_nm1(k+1) )          ! Juan correccion  25 marzo 2022
     3    -(1.d0/(2.d0*h))*(- Bk(k-1)* uf_nm1(k-1)  ! Juan correccion  25 marzo 2022
     4    +(Bk(k-1)+Bk(k))*uf_nm1(k)              ! Juan correccion  25 marzo 2022  
     5    - Bk(k)*uf_nm1(k+1) )                  ! Juan correccion  25 marzo 2022
     6    +0.5d0*cbeta*stheta_n(k-1)
     7    -0.5d0*cbeta*stheta_n(k+1)
         
        rhs(2*k) =coef3 *(2.d0*us_n(k)-us_nm1(k) )
     1          +  coef2*(2.d0*uf_n(k)- uf_nm1(k))
     1          + ((aver_darcy*h*0.5d0)/(2.d0*dt))* uf_nm1(k)
     2       -(1.d0/(2.d0*h))*(-Bk(k-1)*us_nm1(k-1)    ! Juan correccion  25 marzo 2022
     3       + (Bk(k-1)+Bk(k))*us_nm1(k)                ! Juan correccion  25 marzo 2022
     4       - Bk(k)*us_nm1(k+1) )                         ! Juan correccion  25 marzo 2022
     2       -(1.d0/(2.d0*h))*(-Mk(k-1)*uf_nm1(k-1)      ! Juan correccion  25 marzo 2022
     3       + (Mk(k-1)+Mk(k))*uf_nm1(k)                   ! Juan correccion  25 marzo 2022
     4       - Mk(k)*uf_nm1(k+1) )                         ! Juan correccion  25 marzo 2022 
     6    +0.5d0*cbetaf*stheta_n(k-1)
     7    -0.5d0*cbetaf*stheta_n(k+1) 
    
330         continue

c
c    Source   
         do k=2,nx
        
        if(k.eq.jsou)then
            
c            rhs1(k)= rhs1(k)
         rhs(2*k-1) = rhs(2*k-1) 
     1   + source_solid(n)/h
     
c      rhs1(k+1)= rhs1(k+1)
       rhs(2*(k+1)-1) = rhs(2*(k+1)-1) 
     1      -source_solid(n)/h  
     
c       rhs2(k)= rhs2(k) 
         rhs(2*k)= rhs(2*k) 
     1   + source_fluid(n)/h
     
c       rhs2(k+1)= rhs2(k+1)
        rhs(2*(k+1))= rhs(2*(k+1))
     1      -source_fluid(n)/h

                 endif
        
          enddo
          
          do k=1,2*(nx+1)
   !       write(8,*)k,rhs(k)
          enddo
          
c          stop 5
          l = nx
          
        call solver7d (bb,l,rhs,xx)
         
     
           do k=1,(l+1)
           us_np1(k)=xx(2*k-1)
        
           uf_np1(k)=xx(2*k)
            
          enddo
c                   write(6,*) ' uf ' 
               do k=1,(l+1)
   
c           write(6,*)' k,us_np1(k)', k,us_np1(k) 

          enddo
c          write(6,*) ' uf ' 
                      do k=1,(l+1)
   
c           write(6,*)' k,uf_np1(k)', k,uf_np1(k) 

          enddo
          
          
          
  
       return
       end      
***********************************************************************
c subd

      SUBROUTINE SOLVER7d(b,L,RHS,X)


      PARAMETER (ND=6000,NODES=6000)
      IMPLICIT REAL*8(A-H,O-Z)
c$large: b,x,rhs,y,xld,xld1,xld2,xld3,u1,u2,u3
c      complex *16  B(NODES,7)
c      complex*16 X(nodes),RHS(nodes),Y(nodes),XLD(nodes)
c      complex*16 XLD1(nodes),XLD2(nodes),XLD3(nodes),U1(nodes)
c      complex*16 U2(2*ND),U3(2*ND-1)
        real*8 B(2*(NODES+1),7)     
        real*8  X(nodes),RHS(nodes),Y(nodes),XLD(nodes)
        real*8  XLD1(nodes),XLD2(nodes),XLD3(nodes),U1(nodes)
        real*8  U2(2*ND),U3(2*ND-1)
C antes de comenzar la factorizacion verifico que esten definidos
c los elementos de la matriz B a factorizar
c        write(6,*)' enters solver7d' 
        
        do ii=1,2*(l+1)

c       write(6,*)' row ii',ii
c       write(6,*)(b(ii,kk),kk=1,7)
       
        enddo
        
    
 57    format(1x,i3,1x,i1,1x,2g20.8)

C      STARTS FACTORIZATION  L U
C
      XLD(1)=B(1,4)
c      write(70,*)'xld(1) - b(1,4)=',xld(1),b(1,4)
      XLD1(1)=B(2,3)
c      write(70,*)'xld1(1) - b(2,3)=',xld1(1),b(2,3)
      XLD2(1)=B(3,2)
      XLD3(1)=B(4,1)
      U1(1)=B(1,5)/XLD(1)
c      write(70,*)'u1(1)=',U1(1)
      U2(1)=B(1,6)/XLD(1)
      U3(1)=B(1,7)/XLD(1)
      XLD(2)=B(2,4)-XLD1(1)*U1(1)
c      write(70,*)'xld(2)=',xld(2)
c      pause
      XLD1(2)=B(3,3)-XLD2(1)*U1(1)
      XLD2(2)=B(4,2)-XLD3(1)*U1(1)
      XLD3(2)=B(5,1)
      U1(2)=(B(2,5)-XLD1(1)*U2(1))/XLD(2)
      U2(2)=(B(2,6)-XLD1(1)*U3(1))/XLD(2)
      U3(2)=B(2,7)/XLD(2)
      XLD(3)=B(3,4)-XLD2(1)*U2(1)-XLD1(2)*U1(2)
      XLD1(3)=B(4,3)-XLD3(1)*U2(1)-XLD2(2)*U1(2)
      XLD2(3)=B(5,2)-XLD3(2)*U1(2)
      XLD3(3)=B(6,1)
      U1(3)=(B(3,5)-XLD2(1)*U3(1)-XLD1(2)*U2(2))/XLD(3)
      U2(3)=(B(3,6)-XLD1(2)*U3(2))/XLD(3)
      U3(3)=B(3,7)/XLD(3)
c      write(70,*)b(4,4),xld1(3),u1(3),xld2(2),u2(2),xld3(1),u3(1)
           DO  10 I=4,2*L-1
C
C    COMPUTES DIAGONAL ELEMENTS XLD(I) I=1,2*L+2
C
      XLD(I)=B(I,4)-XLD1(I-1)*U1(I-1)-XLD2(I-2)*U2(I-2)
     1         - XLD3(I-3)*U3(I-3)
  
c       WRITE(70,*)'i, xld(i)=',i,xld(I)

C
C     STARTS COMPUTING XLD1 FOR  I=1,2*L+1
C
C
      XLD1(I)=B(I+1,3) - XLD2(I-1)*U1(I-1)-
     1          XLD3(I-2)*U2(I-2)
C
C  STARTS COMPUTING  XLD2(I) I=1,2*L
C
      XLD2(I)= B(I+2,2)- XLD3(I-1)*U1(I-1)
C
C     STARTS COMPUTING  XLD3(I),I=1,2*L-1
C
      XLD3(I)=B(I+3,1)
C
C     STARTS COMPUTING   U1(I) I=1,2*L+1
C
      U1(I) =( B(I,5)- XLD1(I-1)*U2(I-1)-
     1            XLD2(I-2)*U3(I-2) )/XLD(I)
C
C    COMPUTES U2(I)
      U2(I)= ( B(I,6) - XLD1(I-1)*U3(I-1) )/XLD(I)
C
C     COMPUTES U3(I)
C
      U3(I)= B(I,7)/XLD(I)
 10   CONTINUE
      I=2*L
C
C
C    COMPUTES DIAGONAL ELEMENTS XLD(I) I=1,2*L+2
C
      XLD(I)=B(I,4)-XLD1(I-1)*U1(I-1)-XLD2(I-2)*U2(I-2)
     1         - XLD3(I-3)*U3(I-3)
C
c       WRITE(70,*)' I,XLD(I)' , I,XLD(I)
C
C     STARTS COMPUTING XLD1 FOR  I=1,2*L+1
C
C
      XLD1(I)=B(I+1,3) - XLD2(I-1)*U1(I-1)-
     1          XLD3(I-2)*U2(I-2)
C
C  STARTS COMPUTING  XLD2(I) I=1,2*L
C
      XLD2(I)= B(I+2,2)- XLD3(I-1)*U1(I-1)
C
C     STARTS COMPUTING   U1(I) I=1,2*L+1
C
      U1(I) =( B(I,5)- XLD1(I-1)*U2(I-1)-
     #            XLD2(I-2)*U3(I-2) )/XLD(I)
C
C    COMPUTES U2(I)
      U2(I)= ( B(I,6) - XLD1(I-1)*U3(I-1) )/XLD(I)
C
C
      I=2*L+1
C
C
C    COMPUTES DIAGONAL ELEMENTS XLD(I) I=1,2*L+2
C
      XLD(I)=B(I,4)-XLD1(I-1)*U1(I-1)-XLD2(I-2)*U2(I-2)
     1         - XLD3(I-3)*U3(I-3)
C
c      WRITE(70,*)' I,XLD(I)' , I,XLD(I)
C
C     STARTS COMPUTING XLD1 FOR  I=1,2*L+1
C
C
      XLD1(I)=B(I+1,3) - XLD2(I-1)*U1(I-1)-
     1          XLD3(I-2)*U2(I-2)
C     STARTS COMPUTING   U1(I) I=1,2*L+1
C
      U1(I) =( B(I,5)- XLD1(I-1)*U2(I-1)-
     1            XLD2(I-2)*U3(I-2) )/XLD(I)
C
      I=2*L+2
C
C    COMPUTES DIAGONAL ELEMENTS XLD(I) I=1,2*L+2
C
      XLD(I)=B(I,4)-XLD1(I-1)*U1(I-1)-XLD2(I-2)*U2(I-2)
     1         - XLD3(I-3)*U3(I-3)
C
c       WRITE(70,*)' I,XLD(I)' ,  I,XLD(I)

c       write(70,*)' FINISH FAC'

C
C     PERFORMS FORWARD SOLUTION
C
      Y(1) = RHS(1)/XLD(1)
      Y(2)=(RHS(2)-XLD1(1)*Y(1))/XLD(2)
      Y(3)=(RHS(3)-XLD1(2)*Y(2)-XLD2(1)*Y(1))/XLD(3)
      DO 20 I=4,2*L+2
      Y(I) = ( RHS(I) - XLD1(I-1)*Y(I-1) - XLD2(I-2)*Y(I-2)-
     1         XLD3(I-3)*Y(I-3) )/XLD(I)
  20  CONTINUE
C
C      PERFORMS  BACKWARD SOLUTION
C
      X(2*L+2)=Y(2*L+2)
      X(2*L+1)=Y(2*L+1)-U1(2*L+1)*X(2*L+2)
      X(2*L)= Y(2*L) - U1(2*L)*X(2*L+1) - U2(2*L)*X(2*L+2)
      DO 30  I=1,2*L-1
      J= 2*L-I
      X(J) = Y(J) - U1(J)*X(J+1) - U2(J) * X(J+2)
     1         - U3(J) * X(J+3)
  30  CONTINUE
C
c      write(6,*)' back from solver' 
      RETURN
      END        
  

***************************************************************
 
    
      subroutine calc_theta(dt,h,n,rhok,rhofk,ggk,Ek,Bk,Mk,etak,capak,
     1                phik,ck,gammak,tauk,  
     1                nt,nx,source_solid,source_fluid,source_temp,
     2                jsou,jrec1,jrec2,
     2                DL11,DR11,Dl22,DR22,DL12,DR12,
     3        us_nm1,us_n,uf_nm1,uf_n,cbetaf,cbetam,cbeta,cT0,
     4        stheta_n,stheta_nm1,stheta_np1,
     4        lhs1,lhs2,lhs3,rhs1,rhs2,rhs3,abcthetaL,abcthetaR  
     5        ,us_np1,uf_np1)      
 
      implicit none
      integer nodes,ntsteps,mlsour,nx,i,k,n,nt,nmate
      integer jrec1,jrec2,jsou
       parameter(nodes=6000,ntsteps=60000,mlsour=1000,nmate=2)
       real*8  rhok(nodes),Ek(nodes),Bk(nodes),Mk(nodes)
       real*8  tauk(nodes),gammak(nodes)
       real*8  rhofk(nodes),ggk(nodes)
       real*8  etak(nodes),capak(nodes)
       real*8  phik(nodes),ck(nodes)
       real*8  cc(nodes)
        real*8  source_temp(ntsteps)
        real*8  source_solid(ntsteps)
        real*8  source_fluid(ntsteps)
        
       real*8  us_nm1(nodes),us_n(nodes)
       real*8  uf_nm1(nodes),uf_n(nodes) 
       real*8  us_np1(nodes),uf_np1(nodes)       
       real*8  stheta_n(nodes),stheta_nm1(nodes),stheta_np1(nodes)
       real*8 rhs1(nodes),rhs2(nodes),rhs3(nodes)
       real*8 h
       real*8 dt,betaf(nmate),beta(nmate)
       real*8  vthetaL,vthetaR,abcthetaL,abcthetaR
       real*8 coef1,coef2,coef3,coef4
       real*8  rec1_us(ntsteps),rec2_us(ntsteps)
       
       real*8 aver_rho,aver_gg,aver_rhof,aver_darcy
       real*8 DL11,DR11,DL12,DR12,DL22,DR22,DL21,DR21
       real*8 a11, a12, a22,deta
c      write(6,*)' in cacl jrec1, jrec2' ,jrec1,jrec2 
	   real*8 lhs1(nodes,11),lhs2(nodes,11) ! Cambio Juan
	   real*8 lhs3(nodes,11)
       real*8 cbeta,cbetam,cbetaf,cT0
       real*8  Dnm1s_kp1,Dnp1s_k,Dnp1s_kp1,Dnm1f_kp1, Dnm1f_k
       real*8  Dnp1f_k,Dnp1f_kp1, Dnm1s_k
       real*8  D2ns_km1,D2ns_kp1,D2ns_k,D2nf_km1, D2nf_kp1,D2nf_k
       real*8 T100,T101,T102,T103, aux1,aux2
       real*8 avertauc,averc,coef
       real*8 a(nodes),b(nodes),c(nodes),d(nodes)
c     absorbing b.c. at top 
c
c      do k=1,nx
c      ggk(k) = rhok(k)
c      Mk(k) = Ek(k)
c      enddo
        DL11 =  4.7472d6
        DR11 =  4.7472d6
        DL12 = 2.8071d6
        DR12 = 2.8071d6
        DL21= 2.8071d6  
        DR21 = 2.8071d6
        DL22 =  5.8314d6
        DR22 =  5.8314d6
        


c   Starts LHS3(k)  theta      

     
       coef1= (tauk(1)*ck(1)*h*0.5d0)/(dt**2) 
       coef2 = (ck(1)*h*0.5d0)/(2.d0*dt)

     
c       lhs3(1,6)=   coef1+coef2+abcthetaL + gammak(1)/(2.d0*h) ! coef. of theta(1)
       b(1) =  coef1+coef2+abcthetaL + gammak(1)/(2.d0*h) ! coef. of theta(1)
c       write(6,*)' b(1)',b(1)
c       lhs3(1,9)=   - gammak(1)/(2.d0*h) ! coef. of theta(2)
       c(1) = - gammak(1)/(2.d0*h) ! coef. of theta(2)
c       write(6,*)' c(1)',c(1)
       
       k = nx+1
       
       coef1= (tauk(nx)*ck(nx)*h*0.5d0)/(dt**2) 
       coef2 = (ck(nx)*h*0.5d0)/(2.d0*dt)
        
c        lhs3(nx+1,3)= -gammak(nx)/(2.d0*h)  ! coef. of theta(nx)
        a(nx+1) = -gammak(nx)/(2.d0*h)  ! coef. of theta(nx)
  
c       write(6,*)' a(nx+1)',a(nx+1)
c        lhs3(nx+1,6)=  coef1+coef2+abcthetaR 
c     1                +gammak(nx)/(2.d0*h) ! coef. of theta(nx+1)
        b(nx+1) =    coef1+coef2+abcthetaR 
     1                +gammak(nx)/(2.d0*h) ! coef. of theta(nx+1)
c      write(6,*)' b(nx+1)',b(nx+1)
        
        do k=2,nx
        coef1=(tauk(k-1)*ck(k-1)+tauk(k)*ck(k))*h*0.5d0/(dt**2) 
        coef2 = (ck(k-1)+ck(k))*h*0.5d0/(2.d0*dt)
        
   
           
c        lhs3(k,3)= -gammak(k-1)/(2.d0*h) ! coef. of theta(k-1)
        a(k) = -gammak(k-1)/(2.d0*h) ! coef. of theta(k-1)
c        write(6,*)' a(k)',a(k)
     
c        lhs3(k,6) = coef1+coef2 + (gammak(k-1) + gammak(k))/(2.d0*h) ! coef. of theta(k)
        b(k) =     coef1+coef2 + (gammak(k-1) + gammak(k))/(2.d0*h) ! coef. of theta(k)   
c        write(6,*)' b(k)',b(k)
c        lhs3(k,9)= -gammak(k)/(2.d0*h)  ! coef. of theta(k+1)
        c(k) = -gammak(k)/(2.d0*h)  ! coef. of theta(k+1)
c       write(6,*)' c(k)',c(k)
        
        enddo

      

 
c   RHS3
         k=1
       Dnm1s_k = (1.d0/(2.d0*dt))* (us_nm1(2) - us_nm1(1))
 
       Dnp1s_k = (1.d0/(2.d0*dt))* (us_np1(2) - us_np1(1))

      Dnm1f_k = (1.d0/(2.d0*dt))* (uf_nm1(2) - uf_nm1(1))
 
      Dnp1f_k = (1.d0/(2.d0*dt))* (uf_np1(2) - uf_np1(1)) 

      D2ns_k=(1.d0/dt**2)*(us_np1(1)-2.d0*us_n(1)+ us_nm1(1))
 
      D2ns_kp1=(1.d0/dt**2)*(us_np1(2)-2.d0*us_n(2)+ us_nm1(2))

      D2nf_k=(1.d0/dt**2)*(uf_np1(1)-2.d0*uf_n(1)+ uf_nm1(1))
 
      D2nf_kp1=(1.d0/dt**2)*(uf_np1(2)-2.d0*uf_n(2)+ uf_nm1(2))
 
      T100 = phik(1)*cbetaf*cT0*0.5d0*(Dnp1f_k - Dnm1f_k)
 
      T101 = (1.d0-phik(1))*cbetam*cT0*0.5d0*(Dnp1s_k - Dnm1s_k)
 
      T103 = tauk(1)*phik(1)*cbetaf*cT0*0.5d0*(D2nf_kp1 - D2nf_k)
 
      T102 = tauk(1)*(1.d0-phik(1))*cbetam*cT0*0.5d0
     1       *(D2ns_kp1-D2ns_k) 
     
       coef1= (tauk(1)*ck(1)*h*0.5d0)/(dt**2) 
       coef2 = (ck(1)*h*0.5d0)/(2.d0*dt)
   
         
c      rhs3(1) = coef1*(2.d0*stheta_n(1)-stheta_nm1(1)) ! Juan correccion 25 marzo 2022
c     2          + coef2*stheta_nm1(1)+ 
c     3                  abcthetaL*stheta_nm1(1)
c     4    -(1.d0/(2.d0*h))*( gammak(1)* stheta_nm1(1) 
c     5                      -gammak(1)* stheta_nm1(2) )
      d(1) =  coef1*(2.d0*stheta_n(1)-stheta_nm1(1)) ! Juan correccion 25 marzo 2022
     2          + coef2*stheta_nm1(1)+ 
     3                  abcthetaL*stheta_nm1(1)
     4    -(1.d0/(2.d0*h))*( gammak(1)* stheta_nm1(1) 
     5                      -gammak(1)* stheta_nm1(2) )
     6   - (T100 +T101 +T102 + T103)   
     
         k = nx+1
   
       k=nx+1
      
       Dnm1s_k = (1.d0/(2.d0*dt))* (us_nm1(nx+1) - us_nm1(nx)) 
 
       Dnp1s_k = (1.d0/(2.d0*dt))* (us_np1(nx+1) - us_np1(nx))
       
       Dnm1f_k = (1.d0/(2.d0*dt))* (uf_nm1(nx+1) - uf_nm1(nx)) 
 
       Dnp1f_k = (1.d0/(2.d0*dt))* (uf_np1(nx+1) - uf_np1(nx)) 
       
       D2ns_km1=(1.d0/dt**2)*(us_np1(nx)-2.d0*us_n(nx)+ us_nm1(nx)) 
                
       D2ns_k=(1.d0/dt**2)*(us_np1(nx+1)-2.d0*us_n(nx+1)+ us_nm1(nx+1))
       
       D2nf_km1=(1.d0/dt**2)*(uf_np1(nx)-2.d0*uf_n(nx)+ uf_nm1(nx)) 
                
       D2nf_k=(1.d0/dt**2)*(uf_np1(nx+1)-2.d0*uf_n(nx+1)+ uf_nm1(nx+1))
       
       T100 =phik(nx)*cbetaf*cT0*0.5d0*(Dnp1f_k - Dnm1f_k)
       
       T101 = (1.d0-phik(nx))*cbetam*cT0*0.5d0*(Dnp1s_k - Dnm1s_k)
       
       T103 = tauk(nx)*phik(nx)*cbetaf*cT0*0.5d0
     1         *( D2nf_k-D2nf_km1)
       
       T102=tauk(nx)*(1.d0-phik(nx))*cbetam*cT0*0.5d0
     1         *(D2ns_k-D2ns_km1)
       
      coef1= (tauk(nx)*ck(nx)*h*0.5d0)/(dt**2) 
      coef2 = (ck(nx)*h*0.5d0)/(2.d0*dt)
      
      coef = coef1+coef2+abcthetaR
      
c      rhs3(nx+1) = coef1*(2.d0*stheta_n(nx+1)-stheta_nm1(nx+1))
c     2             +coef2 *stheta_nm1(nx+1) 
c     3             +abcthetaR*stheta_nm1(nx+1)
c     4    -(1.d0/(2.d0*h))*(- gammak(nx)* stheta_nm1(nx) 
c     5                + gammak(nx)* stheta_nm1(nx+1) )

       d(nx+1) = coef1*(2.d0*stheta_n(nx+1)-stheta_nm1(nx+1))
     2             +coef2 *stheta_nm1(nx+1) 
     3             +abcthetaR*stheta_nm1(nx+1)
     4    -(1.d0/(2.d0*h))*(- gammak(nx)* stheta_nm1(nx) 
     5                + gammak(nx)* stheta_nm1(nx+1) )
     6     -(T100+T101 +T102 +T103) 

 
       do k=2,nx

       Dnm1s_k = (1.d0/(2.d0*dt))* (us_nm1(k) - us_nm1(k-1)) 
 
       Dnm1s_kp1 = (1.d0/(2.d0*dt))* (us_nm1(k+1) - us_nm1(k))
 
       Dnp1s_k = (1.d0/(2.d0*dt))* (us_np1(k) - us_np1(k-1)) 
 
       Dnp1s_kp1 = (1.d0/(2.d0*dt))* (us_np1(k+1) - us_np1(k))
 
       Dnm1f_k = (1.d0/(2.d0*dt))* (uf_nm1(k) - uf_nm1(k-1)) 
 
       Dnm1f_kp1 = (1.d0/(2.d0*dt))* (uf_nm1(k+1) - uf_nm1(k))
 
       Dnp1f_k = (1.d0/(2.d0*dt))* (uf_np1(k) - uf_np1(k-1))
     
       Dnp1f_kp1 = (1.d0/(2.d0*dt))* (uf_np1(k+1) - uf_np1(k))     
 
       D2ns_km1=(1.d0/dt**2)*(us_np1(k-1)-2.d0*us_n(k-1)+us_nm1(k-1)) 
                
       D2ns_k=(1.d0/dt**2)*(us_np1(k)-2.d0*us_n(k)+ us_nm1(k))
 
       D2ns_kp1=(1.d0/dt**2)*(us_np1(k+1)-2.d0*us_n(k+1)+ us_nm1(k+1))
 
       D2nf_km1=(1.d0/dt**2)*(uf_np1(k-1)-2.d0*uf_n(k-1)+ uf_nm1(k-1)) 
                
       D2nf_k=(1.d0/dt**2)*(uf_np1(k)-2.d0*uf_n(k)+ uf_nm1(k))
 
       D2nf_kp1=(1.d0/dt**2)*(uf_np1(k+1)-2.d0*uf_n(k+1)+ uf_nm1(k+1))

        T100 = cbetaf*cT0*0.5d0*phik(k-1)*(Dnp1f_k-Dnm1f_k)
     1      + cbetaf*cT0*0.5d0*phik(k)*(Dnp1f_kp1 - Dnm1f_kp1)
       
       T101 = cbetam*cT0*0.5d0*(1.d0-phik(k-1))*(Dnp1s_k-Dnm1s_k)
     1    + cbetam*cT0*0.5d0*(1.d0-phik(k))*(Dnp1s_kp1-Dnm1s_kp1)
     
       T103=tauk(k-1)*cbetaf*cT0*0.5d0*phik(k-1)*(D2nf_k-D2nf_km1)
     1       +tauk(k)*cbetaf*cT0*0.5d0*phik(k)*(D2nf_kp1-D2nf_k)
     
        T102=tauk(k-1)*cbetam*cT0*0.5d0*(1.d0-phik(k-1))
     1         *(D2ns_k-D2ns_km1)
     1     + tauk(k)*cbetam*cT0*0.5d0*(1.d0-phik(k))
     1         *(D2ns_kp1-D2ns_k)              
       
       coef1=(tauk(k-1)*ck(k-1)+tauk(k)*ck(k))*h*0.5d0/(dt**2) 
       coef2 = (ck(k-1)+ck(k))*h*0.5d0/(2.d0*dt)
    
      
      avertauc=tauk(k-1)*ck(k-1)+tauk(k)*ck(k) 
      coef1=( avertauc*h*0.5d0)/(dt**2)
      averc = ck(k-1)+ck(k)
      coef2=( averc *h*0.5d0)/(2.d0*dt)

      coef = coef1+coef2
      
c      rhs3(k) = coef1*(2.d0*stheta_n(k)-stheta_nm1(k))+
c     2          coef2 *stheta_nm1(k)+ 
c     3    -(1.d0/(2.d0*h))*(- gammak(k-1)* stheta_nm1(k-1)
c     4    +(gammak(k-1)+gammak(k))*stheta_nm1(k)
c     5    - gammak(k)*stheta_nm1(k+1) )

       d(k) = coef1*(2.d0*stheta_n(k)-stheta_nm1(k))+
     2          coef2 *stheta_nm1(k)+ 
     3    -(1.d0/(2.d0*h))*(- gammak(k-1)* stheta_nm1(k-1)
     4    +(gammak(k-1)+gammak(k))*stheta_nm1(k)
     5    - gammak(k)*stheta_nm1(k+1) )
     6    -(T100 +T101 +T102 +T103)
    
       enddo
       
c    Source   
         do k=2,nx
        
        if(k.eq.jsou)then
  
     
c       rhs3(k)= rhs3(k) 
c     1   + source_temp(n)/h
       d(k) = d(k) + source_temp(n)/h   
c         write(6,*)'source_temp(n)/h,d(k) ',source_temp(n)/h,d(k)
c       rhs3(k+1)= rhs3(k+1) 
c     1      -source_temp(n)/h    
        d(k+1) = d(k+1)  -source_temp(n)/h  
c         write(6,*)'source_temp(n)/h,d(k+1) ',source_temp(n)/h,d(k+1)
                 endif
            
        
          enddo
          
        call    tridia(nx+1,a,b,c,d,stheta_np1)
        
c        do k=1,nx+1
c         write(6,*)' k, a(k),b(k),c(k)', k, a(k),b(k),c(k)
c         enddo
c          do k=1,nx+1
   
c        write(6,*)' k, d(k)', k, d(k)
c        enddo
c           do k=1,nx+1
c        write(6,*)' k, stheta_np1(k)', k, stheta_np1(k)
c        enddo
        
        

       return
       end      
           
************************************************       
         subroutine tridia(n,a,b,c,d,x)
        
        implicit none
        
        integer n, i,j,k
        real*8 a(n),b(n),c(n),d(n),x(n)
        real*8 gama(n), w(n), beta(n)
        
        beta(1)=b(1)
        w(1)=c(1)/beta(1)
        gama(1)=d(1)/beta(1)
        
        do i=2,n-1
                beta(i)=b(i)-a(i)*w(i-1)
                w(i)=c(i)/beta(i)
                gama(i)=(d(i)-a(i)*gama(i-1))/beta(i)  
        end do
        
        beta(n)=b(n)-a(n)*w(n-1)
        gama(n)=(d(n)-a(n)*gama(n-1))/beta(n)  
        
        x(n)=gama(n)
        
        do i=n-1,1,-1
             x(i)= gama(i)-w(i)*x(i+1)
        end do
        
        return
        
        end
                
       
***************************
      subroutine readata(stime,dt,dsize,xsou,freq,fcut,npf,
     1                     h,pos_rec1,pos_rec2,rhos,rhof,
     2                    phi,Tor,gg,eta,capa,T0,ks,kf,
     3                    km,mum,betaf,gamma,cc,beta,tau,betam,
     4                    m,b,ku,E,nt,nx,jsou,jrec1,jrec2,
     5                    DL11,DR11,DL12,DR12,DL21,DR21,
     6                    DL22,DR22,npw,nmat,vfast,vslow,
     7                    vmin_biot,vmax_biot) 
       
        implicit none
        integer nodes,ntsteps,nx,i,k,n,nt,npf,mlsour,npw,nmate
        integer npar
        parameter(nodes=6000,ntsteps=60000,mlsour=1000,nmate=2)
        real*8 stime,dt,dsize,xsou,freq,fcut,h
        real*8 rhos(nmate),rhof(nmate),phi(nmate)
        real*8 Tor(nmate),gg(nmate),eta(nmate)
        real*8 capa(nmate),T0(nmate),ks(nmate)
        real*8 kf(nmate)
        real*8 km(nmate),mum(nmate),betaf(nmate)
        real*8 gamma(nmate),cc(nmate),beta(nmate)
        real*8 tau(nmate),betam(nmate)
        real*8 m(nmate),b(nmate),E(nmate)
        real*8 ku(nmate),num,den,alpha
        real*8 DL11,DR11,DL12,DR12,DL21,DR21,DL22,DR22
        
        real*8 pos_rec1,pos_rec2
        integer jrec1,jrec2,jsou,nmat
        real*8 vminL, vmaxL,vminR,vmaxR,secfac,hrefL,wavelL
        real*8 hrefR,wavelR,dtL,dtR
        real*8 href,vmin_biot,vmax_biot,wavel
        real*8 vslow,vfast
        real*8 vmin_theta,vmax_theta,abcthetaL,abcthetaR
        real*8 vmin,vthetaL,vthetaR
        
        read(5,*)nmat
        write(6,*)' nmat' ,nmat
        read(5,*)stime
        write(6,*)' stime     ',stime
        read(5,*)dt
        write(6,*)'dt (se cambia)        ',dt
        read(5,*)dsize
        write(6,*)'dsize      ',dsize
        read(5,*)xsou
        write(6,*)'xsou       ',xsou   
        read(5,*)freq
        write(6,*)'freq       ',freq          
        read(5,*)fcut
        write(6,*)'fcut       ',fcut   
        read(5,*)npf
        write(6,*)'npf       ',npf          
        
        read(5,*)h
        write(6,*)'h (se cambia)         ',h
        
        
        
        read(5,*)pos_rec1
        write(6,*)' pos_rec1 ', pos_rec1           
        read(5,*)pos_rec2
        write(6,*)' pos_rec2 ', pos_rec2              
        read(5,*)npw
         write(6,*)' npw  ',npw
    
    
        do 1 i=1,nmat
        
        read(5,*)rhos(i)
        read(5,*)rhof(i) 
        read(5,*)phi(i)
        read(5,*)Tor(i) 
        read(5,*)eta(i)
        read(5,*)capa(i)
            
        read(5,*)T0(i)
        read(5,*)ks(i)
        read(5,*)kf(i)
        read(5,*)km(i)
        read(5,*)mum(i)
        read(5,*)betaf(i)
        read(5,*)gamma(i)
             
        read(5,*)cc(i)
    
        read(5,*)beta(i) 
        
        read(5,*)tau(i)

        write(6,*)' rhos(i)  ',rhos(i) 
        write(6,*)' rhof(i)  ',rhof(i)
        write(6,*)' phi(i)   ',phi(i)
        write(6,*)' Tor(i)   ',Tor(i)  
        write(6,*)' eta(i)   ',eta(i)
        write(6,*)' capa(i)  ',capa(i) 
        write(6,*)' T0(i)    ',T0 (i)
        write(6,*)' ks(i)   ',ks(i)
        write(6,*)' kf(i)    ',kf (i)
        write(6,*)' km(i)    ',km(i)
        write(6,*)' mum(i)   ',mum(i)
        write(6,*)' betaf(i) ',betaf(i)
        write(6,*)' gamma(i) ',gamma(i)
        write(6,*)' cc(i)    ',cc(i)
        write(6,*)' beta(i)  ',beta(i) 
        write(6,*)' tau(i)   ',tau(i)
        betam(i) = beta(i) - betaf(i)
        write(6,*)' betam(i)  ',betam(i) 
        gg(i)= Tor(i)*rhof(i)/phi(i)
        write(6,*)' gg(i)    ',gg(i)
1       continue
 

         
c   computes Biot  properties
        do i=1,nmat
        alpha = 1.d0 - km(i)/ks(i)
        num = ks(i)**2 * kf(i)
        den=ks(i)*phi(i)*(ks(i) - kf(i)) + kf(i)*(ks(i) - km(i))
        m(i) = num/den
        b(i) = alpha *m(i) 
        ku(i) = km(i) + alpha**2 * m(i)
        E(i) = ku(i) + (4.d0/3.d0)* mum(i)
        write(6,*)' Biot elastic constants' 
         
        write(6,*) ' m(i)   ',m(i)
        write(6,*) ' b(i)   ',b(i)
        write(6,*) ' ku(i)  ',ku(i)
        write(6,*) ' E(i)   ',E(i)
        enddo
        
        
        
c   computes ABC for uniform medium

        
        DL11 =  4.7472d6
        DR11 =  4.7472d6
        DL12 = 2.8071d6
        DR12 = 2.8071d6
        DL21= 2.8071d6  
        DR21 = 2.8071d6
        DL22 =  5.8314d6
        DR22 =  5.8314d6      

          vmin_biot = 700.d0
          vmax_biot = 2200.d0
          vslow = vmin_biot
          vfast=vmax_biot
          

        if(nmat.eq.1)then
        
        
        vmin_theta =   dsqrt(gamma(1)/(tau(1)*cc(1)))  
        vmax_theta =   dsqrt(gamma(1)/(tau(1)*cc(1)))
        vmin = vmin_theta
        if(vmin.gt.vmin_biot)then
        vmin= vmin_biot
        endif
        
        wavel = vmin/freq

        href = wavel/npw
        h = href
        secfac = 0.5d0
        dt = ( href/vmax_biot) * secfac
        
        
        endif
        
         wavel = vmin_biot/freq

        href = wavel/npw
        h = href
        secfac = 0.1d0
        dt = ( href/vmax_biot) * secfac
 !       h=1.d0
        
 !       dt=0.01
c        write(6,*)' cambio h a 1' 
        
               write(6,*)' ********************'
               
        write(6,*)' use  vmin_biot' 
        write(6,*)'to compute dt, h for uniform medium'  
      write(6,*)' wavel,vmin,npw  ',wavel,vmin,npw
      
        write(6,*)' ***********************************'
        write(6,*)
      write(6,*)'new  h=href  computed using npw ',href
      write(6,*)
      
      write(6,*)' new  time step dt (s) ',dt
      write(6,*)
         write(6,*)' ***********************************'     

 
  !     h=1.d0   
        nt = stime/dt 
 !       nt=1
        if(nt.gt.ntsteps)then
        write(6,*)' nt greather than max. memory allows'
        write(6,*)'parameter  ntsteps must be increased'
        write(6,*)' nt ',nt,' ntsteps ',ntsteps
        
        stop 123456
        endif
        
   !     h=1.d0
        nx = dsize/h 
        
        if(nx.gt.nodes)then
         write(6,*)' nx greather than max. memory allows'
        write(6,*)'parameter nodes must be increased'  
        write(6,*)' nx ',nx,' nodes ',nodes
        stop 234567
        endif
        
        jsou = xsou/h 
        write(6,*)' cambio jsour a jsou+1 para este ejemplo' 
        
        jsou =jsou+1
         jrec1 = pos_rec1/h
         jrec2 = pos_rec2/h+h       
         write(6,*)' in readata' 
          
         write(6,*)' ***********************************'    
         write(6,*)' nt ',nt
         write(6,*)' nx ',nx
         write(6,*)' jsou ',jsou
         write(6,*)' jrec1 ',jrec1       
         write(6,*)' jrec2 ',jrec2         
         

        write(6,*)' salgo de readata' 
        
  
            
          return
          end

***************************************************
        subroutine sources(freq,fcut,stime,dt,nt,npf,
     1 source_solid,source_fluid,source_temp)
       
        implicit none
        integer nodes,ntsteps,mlsour,nx,i,k,n,lpulse,nt,jw2
        integer npf
        parameter(nodes=6000,ntsteps=60000,mlsour=1000)
        real*8  source_temp(ntsteps)
        real*8  source_solid(ntsteps)
        real*8  source_fluid(ntsteps)
        
        real*8 pi,twopi,psi,width,w0,alfaf,ts,totpul,fcut
        complex*16 x(mlsour),fsour(mlsour)
        real*8 tt,aux,xmax,stime,freq,dt,fny,fnpf,delf,delw

        open(unit=1,file='temp_source')
        open(unit=2,file='solid_source')
        open(unit=3,file='fluid_source')
        
        open(unit=4,file='amplitud_temp_source')

        
        pi=dabs(4.d0*datan(1.d0))
        twopi = 2.d0*pi
        
c        nt = stime/dt
        write(6,*)'number of time steps',nt

        fny =  1.d0/(2.d0*dt)
        write(6,*)' nyquist frequency  (Hz) = ', fny

        fnpf=npf
        delf=fcut/fnpf
        delw = twopi*delf
        write(6,*)' delf',delf,'delw ',delw
        jw2= fcut/delf  ! last index for frequencies
         
      
      w0 = twopi*freq
      alfaf= .79d0 * w0/pi
      psi=8.d0*freq**2
      width=.5d0/freq
      ts=2.5d0*width
      totpul=3.0d0*ts
      lpulse=totpul/dt+1.0001d0
  
	   
      write(6,*)' w0 = ',w0,'  alfaf = ',alfaf
      write(6,*)' lpulse = ',lpulse
      
       if(lpulse.gt.ntsteps)stop 12345
       
      write(6,*)'psi=',psi,'width=',width,'sec'
      write(6,*)'ts = ', ts, 'totpul',totpul
      write(6,*)'nt = pulse length in samples',nt
 
      if(nt.lt.lpulse)nt=lpulse
      do  n=1,nt
      tt=(n-1)*dt
      aux=psi*(tt-ts)**2
      source_temp(n)=-2.d0*psi*(tt-ts)*exp(-aux)
      enddo
        
c       forces the max value of the source to be one
c
        xmax = 0.d0
        do n=1,nt
        if(dabs(source_temp(n)).gt.xmax) xmax = dabs(source_temp(n))
        enddo

        do  n=1,nt
        source_temp(n) = source_temp(n)/xmax
         if(dabs(source_temp(n)).lt.1.e-14) source_temp(n) = 0.d0
         enddo
         
         do n=1,nt
         source_temp(n) = source_temp(n)
c         source_solid(n) = source_temp(n)*1.d+4
c         source_fluid(n) = source_temp(n)*1.d+4
          
          source_solid(n) = source_temp(n)
c          source_temp(n) = 0.d0
          source_fluid(n) = source_temp(n)
c           source_fluid(n) = 0.d0
         enddo
c
c     writes in 1 source time shape 
c
       write(1,270)((n-1)*dt,source_temp(n),n=1,nt)
       write(2,270)((n-1)*dt,source_solid(n),n=1,nt)
       write(3,270)((n-1)*dt,source_fluid(n),n=1,nt)
       
       
       
270   format(2e20.8)

c
c     computes amplitude and phase of the periodic source
c
    
      call ffu2(source_temp,nt,x,jw2,dt,delw)
      
c     writes amplitude  spectrum in  2
      
       
       write(4,270)((n-1)*delf+.5d0*delf,dsqrt( dreal(x(n))**2
     1              + dimag(x(n))**2),n=1,jw2)
      
      
          return
          end       
**********************************************************************
      subroutine ffu2(u,nt,fu,nw,dt,delw)
      
      implicit none
      integer nodes,ntsteps,mlsour
            parameter(nodes=6000,ntsteps=60000,mlsour=1000)
      integer jw,jt,nt,nw
      real*8 fjw,fjt,v,dt,delw
      real*8 u(ntsteps)
      complex*16  fu(mlsour)
      do  3 jw = 1,nw
      fjw = jw
      fjw = fjw-1.d0
      fjw = fjw + .5d0
      fu(jw) = dcmplx(0.d0,0.d0)
      do 4  jt = 1,nt
      fjt = jt
      fjt = fjt - 1.d0
      v = fjw*delw* fjt*dt
      v=-v
      fu(jw) = fu(jw) + u(jt) * dcmplx(dcos(v),dsin(v))
 4    continue
      fu(jw)=fu(jw)*dt
 
 3    continue
      return
      end 

      !***********************************************
      
      subroutine build_matrix(nx,lhs1,lhs2,rhs1,rhs2,lhs3,rhs3, 
     1            matrix,rhs)
     
           implicit none
          integer nodes,ntsteps,mlsour
          parameter(nodes=6000,ntsteps=60000,mlsour=1000)
          integer nx,i,j,k, ndim
          real*8 lhs1(nodes,11), lhs2(nodes,11)
          real*8 rhs1(nodes), rhs2(nodes)
          real*8 lhs3(nodes,11), rhs3(nodes)
          real*8 matrix(3*nodes,11), rhs(3*nodes)
          
          ndim=3*(nx+1)
          
          do i=1, ndim
          
            do j=1,11
                matrix(i,j)=0.d0
            end do
            
          end do
 
 !column 1    Temp(k,1)   k=2,...   
            matrix(6,1)=lhs3(2,1)
            do k=3,nx+1
                matrix(3*k,1)=lhs3(k,1)
            end do
            
 !column 2   LHS2(k,1), Temp(k,2)   k=2,...         
            
            do k=2,nx+1
                matrix(3*k-1,2)=lhs2(k,1)
                matrix(3*k,2)=lhs3(k,2)
            end do 
            
 !column 3 LHS1(k,1),LHS2(k,2), Temp(k,3)
           
           do k=2,nx+1
            matrix(3*k-2,3)=lhs2(k,1)
            matrix(3*k-1,3)=lhs2(k,2)
            matrix(3*k,3)=lhs3(k,3)
 
            end do
 !column 4  LHS1(k,2), LHS2(k,3), Temp(k,4) k=2,...  
 
            matrix(3,4)=lhs3(1,1)
            
            do k=2,nx+1
            matrix(3*k-2,4)=lhs1(k,2)
            matrix(3*k-1,4)=lhs2(k,3)
            matrix(3*k,4)=lhs3(k,4)
 
            end do
          
  !column 5  LHS1(k,3),LHS2(k,4), Temp(k,5) k=2,...              

  
            matrix(2,5)=lhs2(1,1)
            matrix(3,5)=lhs3(1,2)
            
            do k=2,nx+1
             matrix(3*k-2,5)=lhs1(k,3)
             matrix(3*k-1,5)=lhs2(k,4)
             matrix(3*k,5)=lhs3(k,5)
            end do
            
!column 6  LHS1(k,4),LHS2(k,5), Temp(k,6) k=2,...                    
 
            matrix(1,6)=lhs1(1,1)
            matrix(2,6)=lhs2(1,2)
            matrix(3,6)=lhs3(1,3)

            do k=2,nx+1
             matrix(3*k-2,6)=lhs1(k,4)
             matrix(3*k-1,6)=lhs2(k,5)
             matrix(3*k,6)=lhs3(k,6)
            end do
            
!column 7  LHS1(k,5),LHS2(k,6),Temp(k,7) k=2,...                    
 
            matrix(1,7)=lhs1(1,2)
            matrix(2,7)=lhs2(1,3)
            matrix(3,7)=lhs3(1,4)
      
            
            do k=2,nx
             matrix(3*k-2,7)=lhs1(k,5)
             matrix(3*k-1,7)=lhs2(k,6)
             matrix(3*k,7)=lhs3(k,7)
            end do  
            
             matrix(3*nx+1,7)=lhs1(nx+1,5)
             matrix(3*nx+2,7)=lhs2(nx+1,6)
             
 !column 8  LHS2(k,7),Temp(k,8) k=2,.,nx, LHS1(nx+1,4)                             
              
            matrix(1,8)=lhs1(1,3)
            matrix(2,8)=lhs2(1,4)
            matrix(3,8)=lhs3(1,5)
            
            do k=2,nx
             matrix(3*k-2,8)=0.d0
             matrix(3*k-1,8)=lhs2(k,7)
             matrix(3*k,8)=lhs3(k,8)
            end do  
            
             matrix(3*nx+1,8)=lhs1(nx+1,6)
 
!column 9  LHS1(k,7),LHS2(k,8),Temp(k,9) k=2,... 

            matrix(1,9)=lhs1(1,4)
            matrix(2,9)=lhs2(1,5)
            matrix(3,9)=lhs3(1,6)

            do k=2,nx
             matrix(3*k-2,9)=lhs1(k,7)
             matrix(3*k-1,9)=lhs2(k,8)
             matrix(3*k,9)=lhs3(k,9)
            end do  

!column 10  LHS2(1,6),LHS2(k,7) k=2,.,nx

            matrix(1,10)=lhs1(1,5)
            matrix(2,10)=lhs2(1,6)
            matrix(3,10)=0.d0

            
            do k=3,nx
             matrix(3*k-2,10)=lhs1(k,8)
             matrix(3*k-1,10)=lhs2(k,9)
             matrix(3*k,10)=0.d0
            end do  

!column 11  LHS1(1,6),LHS1(k,9) k=2,.,nx

            matrix(1,11)=lhs1(1,6)
             
            do k=2,nx
             matrix(3*k-2,11)=lhs1(k,9)
             matrix(3*k-1,11)=0.d0
             matrix(3*k,11)=0.d0
            end do  


            do k=1,nx+1
  !              write(6,*) k
            rhs(3*k-2)=rhs1(k)
            rhs(3*k-1)=rhs2(k) 
            rhs(3*k)=rhs3(k) 
            
            end do
 
            return
            end
            
       SUBROUTINE LEQT1B(A,N,NLC,NUC,IA,B,M,IB,IJOB,XL)
C
C FUNCTION: MATRIX DECOMPOSITION, LINEAR EQUATION SOLUTION
C - SPACE ECONOMIZER SOLUTION - BAND STORAGE MODE
C
C PARAMETERS:
C A = INPUT/OUTPUT MATRIX OF DIMENSION N BY (NUC+NLC+1).
C SEE PARAMETER IJOB.
C  THE COLUMNS OF THE A ARRAY CONTAIN THE DIAGONALS OF THE COEFFICIENT
c MATRIX, THE LOWERMOST DIAGONAL IN COLUMN 1, ETC. (THIS
c IS THE BAND STORAGE MODE REQUIRED BY IMSL ROUTINE LEQT2B.)
C N = ORDER OF MATRIX A AND THE NUMBER OF ROWS IN B
C (INPUT).
C NLC = NUMBER OF LOWER CODIAGONALS IN MATRIX A (INPUT).
C NUC = NUMBER OF UPPER CODIAGONALS IN MATRIX A (INPUT).
C lA = ROW DIMENSION OF A AS SPECIFIED IN THE CALLING
C PROGRAM (INPUT).
C B = INPUT/OUTPUT MATRIX OF DIMENSION N BY M. ON INPUT,
C B CONTAINS THE M RIGHT-HAND SIDES OF THE EQUATION
C AX=B. ON OUTPUT, THE SOLUTION MATRIX X REPLACES B.
C IF IJ0B=1, B IS NOT USED.
C M = NUMBER OF RIGHT-HAND SIDES (COLUMNS IN B).
C IB = ROW DIMENSION OF B AS SPECIFIED IN THE CALLING
C PROGRAM (INPUT).
C IJOB = INPUT OPTION PARAMETER. IJOB=I IMPLIES:
C WHEN 1=0, FACTOR THE MATRIX A AND SOLVE THE EQUATION
C AX=B. ON INPUT, A CONTAINS THE COEFFICIENT MATRIX
C OF THE EQUATION AX=B, WHERE A IS ASSUMED TO BE AN
C N BY N BAND MATRIX. A IS STORED IN BAND STORAGE
C MODE AND THEREFORE HAS DIMENSION N BY (NLC+NUC+1).
C ON OUTPUT, A IS REPLACED BY THE U MATRIX OF THE L-U
C DECOMPOSITION OF A ROWWISE PERMUTATION OF MATRIX A.
C U IS STORED IN BAND STORAGE MODE.
C WHEN 1=1, FACTOR THE MATRIX A. A CONTAINS THE SAME
C INPUT/OUTPUT INFORMATION AS IF IJ0B=O. 
C WHEN 1=2, SOLVE THE EQUATION AX=B. THIS OPTION
C IMPLIES THAT LEQTIB HAS ALREADY BEEN CALLED USING
C IJ0B=O OR 1 SO THAT THE MATRIX A HAS ALREADY BEEN
C FACTORED. IN THIS CASE, OUTPUT MATRICES A AND XL
C MUST HAVE BEEN SAVED FOR REUSE IN THE CALL TO
C LEQTIB.
C XL = WORK AREA OF DIMENSION N*(NLC+1). THE FIRST NLC*N
C LOCATIONS OF XL CONTAIN COMPONENTS OF THE L MATRIX OF
C THE L-U DECOMPOSITION OF A ROWWISE PERMUTATION OF A.
C THE LAST N LOCATIONS CONTAIN THE PIVOT INDICES.

!	        IMPLICIT NONE
! REAL*8 (A-H,O-Z)
            parameter(nodes=6000,ntsteps=60000,mlsour=1000,nmate=2)
             integer N,NLC,NUC,IA,M,IB,IJOB
             integer JBEG,NLC1,J,I,NC,NN
             integer JEND,K,L,K1,IK,KK             
             REAL*8  A(3*nodes,11),XL(3*nodes,11),B(3*nodes)
             REAL*8 RN, P,Q
             
             
 !           DATA ZERO/O./, ONE/1.0/
 
  !        do k=1,11
  !           write(43,*) 'columna',k
  !           do j=1,N
  !          write(43,14) A(j,k)
 !           end do
 !  14        format(e15.7) 
 !         end do
             
        

C
            JBEG = NLC + 1 
            NLC1 = JBEG
            IF (IJOB .EQ. 2) GO TO 80
            RN = N
C
            
c              WRITE(*,*)'subroutine banda'
            do j=1,NLC+NUC+1
c                WRITE(*,*)'columna',j
                do i=1,N
c                  WRITE(*,*)A(I,J)
                end do
c            WRITE(*,*)
            END DO
c        WRITE(*,*)'RHS'
		DO I=1,N
c           WRITE(*,*) i, B(I)
        END DO
 !           PAUSE

C RESTRUCTURE THE MATRIX. FIND RECIPROCAL OF THE LARGEST
C ABSOLUTE VALUE IN ROW 1
C
            I = 1
            NC = JBEG + NUC
            NN = NC
            JEND = NC
            IF (N .EQ. 1 .OR. NLC .EQ. 0) GO TO 25
  5         K = 1
            P = 0.
            DO 10 J=JBEG,JEND
                A(I,K) = A(I,J)
                Q = ABS(A(I,K))
                IF (Q .GT. P) P = Q 
                K = K + 1
  10        CONTINUE
            IF (P .EQ. 0.) GO TO 135
            XL(I,NLC1) = 1.0/P
            IF (K .GT. NC) GO TO 20
            DO 15 J=K,NC
                A(I,J) = 0.d0
  15        CONTINUE
  20        I = I + 1
            JBEG = JBEG - 1
            IF (JEND - JBEG .EQ. N) JEND = JEND - 1
            IF (I .LE. NLC) GO TO 5
            JBEG = I
            NN = JEND
  25        JEND = N - NUC
            DO 40 I=JBEG,N
                    P = 0.
                DO 30 J=1,NN
                    Q = ABS(A(I,J))
                    IF (Q .GT. P) P = Q
  30            CONTINUE
                IF (P .EQ. 0.) GO TO 135
                XL(I,NLC1) = 1.0/P
                IF (I .EQ. JEND) GO TO 37
                IF (I .LT. JEND) GO TO 40 
                K = NN + 1
                DO 35 J=K,NC
                    A(I,J) = 0.
  35            CONTINUE
  37            NN = NN - 1
  40        CONTINUE
            L = NLC
C 
C L-U DECOMPOSITION
C
            DO 75 K=1,N
  !              write(6,*)'LEQT1B LU', k
                   P = ABS(A(K,1))*XL(K,NLC1)
                I = K
                IF (L .LT. N) L = L + 1
                K1 = K + 1
                IF (K1 .GT. L) GO TO 50
                DO 45 J=K1,L
                    Q = ABS(A(J,1))*XL(J,NLC1)
                    IF (Q .LE. P) GO TO 45
                    P = Q
                    I = J
  45            CONTINUE
  50            XL(I,NLC1) = XL(K,NLC1)
                XL(K,NLC1) = I
C
C SINGULARITY FOUND
C
                IF (RN+P .EQ. RN) GO TO 135
C
C INTERCHANGE ROWS I AND K
C
                IF (K .EQ. I) GO TO 60
                DO 55 J=1,NC
                    P = A(K,J)
                    A(K,J) = A(I,J)
                    A(I,J) = P
  55            CONTINUE
  60            IF (K1 .GT. L) GO TO 75
                DO 70 I=K1,L
                    P = A(I,1)/A(K,1)
                    IK = I - K 
                    XL(K1,IK) = P
                    DO 65 J=2,NC
                        A(I,J-1) = A(I,J) - P*A(K,J)
  65                CONTINUE
                    A(I,NC) = 0.
  70            CONTINUE
  75        CONTINUE
            IF (IJOB .EQ. 1) GO TO 9005
C
C FORWARD SUBSTITUTION
C
  80        L = NLC
            DO 105 K=1,N
                I = XL(K,NLC1)
                IF (I .EQ. K) GO TO 90
 !               DO 85 J=1,M
                    P = B(K)
                    B(K) = B(I)
                    B(I) = P
  85            CONTINUE
  90            IF (L .LT. N) L = L+1
                K1 = K + 1
                IF (K1 .GT. L) GO TO 105
c               write(*,*)'L', L
                DO 100 I=K1,L
                    IK = I - K
                    P = XL(K1,IK)
 !                   DO 95 J=1,M
                        B(I) = B(I) - P*B(K)
c               write(*,*)'B(',I,')', B(I)
  95                CONTINUE
            
 100            CONTINUE
c                   write(*,*)'B(',I,')', B(I)
      !      pause
 105        CONTINUE
    
C
C BACKWARD SUBSTITUTION 
            JBEG = NUC + NLC
  !          DO 125 J=1,M
                L = 1
                K1 = N + 1
                DO 120 I=1,N
                    K = K1 - I
                    P = B(K)
                    IF (L .EQ. 1) GO TO 115
                    DO 110 KK=2,L
                        IK = KK + K
                        P = P - A(K,KK)*B(IK-1)
 110                CONTINUE
 115                B(K) = P/A(K,1)
                    IF (L .LT. JBEG) L = L + 1
 120            CONTINUE
 125        CONTINUE
C
 9005       RETURN
C
 135        CONTINUE

            WRITE(6,1000)
 1000       FORMAT('LEQTIB ERROR—MATRIX ALGORITHMICALLY* SINGULAR *')
 !           stop 6
            END 
               
            
        
            
            
